/* PageChecker.c generated by valac 0.56.13, the Vala compiler
 * generated from PageChecker.vala, do not modify */

/*
 * Copyright (c) 2017-2019 elementary, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "slingshot.h"
#include <handy.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

enum  {
	SLINGSHOT_WIDGETS_PAGE_CHECKER_0_PROPERTY,
	SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGINATOR_PROPERTY,
	SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGE_PROPERTY,
	SLINGSHOT_WIDGETS_PAGE_CHECKER_NUM_PROPERTIES
};
static GParamSpec* slingshot_widgets_page_checker_properties[SLINGSHOT_WIDGETS_PAGE_CHECKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SlingshotWidgetsPageCheckerPrivate {
	HdyCarousel* _paginator;
	GtkWidget* _page;
	gint page_number;
};

static gint SlingshotWidgetsPageChecker_private_offset;
static gpointer slingshot_widgets_page_checker_parent_class = NULL;
static GtkCssProvider* slingshot_widgets_page_checker_provider;
static GtkCssProvider* slingshot_widgets_page_checker_provider = NULL;

static void slingshot_widgets_page_checker_update_opacity (SlingshotWidgetsPageChecker* self);
static GObject * slingshot_widgets_page_checker_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _slingshot_widgets_page_checker___lambda39_ (SlingshotWidgetsPageChecker* self);
static void __slingshot_widgets_page_checker___lambda39__gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self);
static void _slingshot_widgets_page_checker___lambda40_ (SlingshotWidgetsPageChecker* self);
static void __slingshot_widgets_page_checker___lambda40__g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void _slingshot_widgets_page_checker___lambda41_ (SlingshotWidgetsPageChecker* self);
static void __slingshot_widgets_page_checker___lambda41__gtk_widget_destroy (GtkWidget* _sender,
                                                                      gpointer self);
static void slingshot_widgets_page_checker_finalize (GObject * obj);
static GType slingshot_widgets_page_checker_get_type_once (void);
static void _vala_slingshot_widgets_page_checker_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_slingshot_widgets_page_checker_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
slingshot_widgets_page_checker_get_instance_private (SlingshotWidgetsPageChecker* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotWidgetsPageChecker_private_offset);
}

SlingshotWidgetsPageChecker*
slingshot_widgets_page_checker_construct (GType object_type,
                                          HdyCarousel* paginator,
                                          GtkWidget* page)
{
	SlingshotWidgetsPageChecker * self = NULL;
#line 31 "../src/Widgets/PageChecker.vala"
	g_return_val_if_fail (paginator != NULL, NULL);
#line 31 "../src/Widgets/PageChecker.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 32 "../src/Widgets/PageChecker.vala"
	self = (SlingshotWidgetsPageChecker*) g_object_new (object_type, "paginator", paginator, "page", page, NULL);
#line 31 "../src/Widgets/PageChecker.vala"
	return self;
#line 99 "PageChecker.c"
}

SlingshotWidgetsPageChecker*
slingshot_widgets_page_checker_new (HdyCarousel* paginator,
                                    GtkWidget* page)
{
#line 31 "../src/Widgets/PageChecker.vala"
	return slingshot_widgets_page_checker_construct (SLINGSHOT_WIDGETS_TYPE_PAGE_CHECKER, paginator, page);
#line 108 "PageChecker.c"
}

static void
slingshot_widgets_page_checker_update_opacity (SlingshotWidgetsPageChecker* self)
{
	gdouble progress = 0.0;
	HdyCarousel* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 67 "../src/Widgets/PageChecker.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/Widgets/PageChecker.vala"
	_tmp0_ = self->priv->_paginator;
#line 68 "../src/Widgets/PageChecker.vala"
	_tmp1_ = hdy_carousel_get_position (_tmp0_);
#line 68 "../src/Widgets/PageChecker.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/Widgets/PageChecker.vala"
	progress = MAX (1 - fabs (_tmp2_ - self->priv->page_number), (gdouble) 0);
#line 70 "../src/Widgets/PageChecker.vala"
	gtk_widget_set_opacity ((GtkWidget*) self, SLINGSHOT_WIDGETS_PAGE_CHECKER_MIN_OPACITY + ((1 - SLINGSHOT_WIDGETS_PAGE_CHECKER_MIN_OPACITY) * progress));
#line 130 "PageChecker.c"
}

HdyCarousel*
slingshot_widgets_page_checker_get_paginator (SlingshotWidgetsPageChecker* self)
{
	HdyCarousel* result;
	HdyCarousel* _tmp0_;
#line 25 "../src/Widgets/PageChecker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/PageChecker.vala"
	_tmp0_ = self->priv->_paginator;
#line 25 "../src/Widgets/PageChecker.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/PageChecker.vala"
	return result;
#line 146 "PageChecker.c"
}

static void
slingshot_widgets_page_checker_set_paginator (SlingshotWidgetsPageChecker* self,
                                              HdyCarousel* value)
{
	HdyCarousel* old_value;
#line 25 "../src/Widgets/PageChecker.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/PageChecker.vala"
	old_value = slingshot_widgets_page_checker_get_paginator (self);
#line 25 "../src/Widgets/PageChecker.vala"
	if (old_value != value) {
#line 25 "../src/Widgets/PageChecker.vala"
		self->priv->_paginator = value;
#line 25 "../src/Widgets/PageChecker.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_page_checker_properties[SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGINATOR_PROPERTY]);
#line 164 "PageChecker.c"
	}
}

GtkWidget*
slingshot_widgets_page_checker_get_page (SlingshotWidgetsPageChecker* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 26 "../src/Widgets/PageChecker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Widgets/PageChecker.vala"
	_tmp0_ = self->priv->_page;
#line 26 "../src/Widgets/PageChecker.vala"
	result = _tmp0_;
#line 26 "../src/Widgets/PageChecker.vala"
	return result;
#line 181 "PageChecker.c"
}

static void
slingshot_widgets_page_checker_set_page (SlingshotWidgetsPageChecker* self,
                                         GtkWidget* value)
{
	GtkWidget* old_value;
#line 26 "../src/Widgets/PageChecker.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/PageChecker.vala"
	old_value = slingshot_widgets_page_checker_get_page (self);
#line 26 "../src/Widgets/PageChecker.vala"
	if (old_value != value) {
#line 26 "../src/Widgets/PageChecker.vala"
		self->priv->_page = value;
#line 26 "../src/Widgets/PageChecker.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_page_checker_properties[SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGE_PROPERTY]);
#line 199 "PageChecker.c"
	}
}

static void
_slingshot_widgets_page_checker___lambda39_ (SlingshotWidgetsPageChecker* self)
{
	HdyCarousel* _tmp0_;
	GtkWidget* _tmp1_;
#line 55 "../src/Widgets/PageChecker.vala"
	_tmp0_ = self->priv->_paginator;
#line 55 "../src/Widgets/PageChecker.vala"
	_tmp1_ = self->priv->_page;
#line 55 "../src/Widgets/PageChecker.vala"
	hdy_carousel_scroll_to (_tmp0_, _tmp1_);
#line 214 "PageChecker.c"
}

static void
__slingshot_widgets_page_checker___lambda39__gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self)
{
#line 54 "../src/Widgets/PageChecker.vala"
	_slingshot_widgets_page_checker___lambda39_ ((SlingshotWidgetsPageChecker*) self);
#line 223 "PageChecker.c"
}

static void
_slingshot_widgets_page_checker___lambda40_ (SlingshotWidgetsPageChecker* self)
{
#line 59 "../src/Widgets/PageChecker.vala"
	slingshot_widgets_page_checker_update_opacity (self);
#line 231 "PageChecker.c"
}

static void
__slingshot_widgets_page_checker___lambda40__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 58 "../src/Widgets/PageChecker.vala"
	_slingshot_widgets_page_checker___lambda40_ ((SlingshotWidgetsPageChecker*) self);
#line 241 "PageChecker.c"
}

static void
_slingshot_widgets_page_checker___lambda41_ (SlingshotWidgetsPageChecker* self)
{
#line 63 "../src/Widgets/PageChecker.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 249 "PageChecker.c"
}

static void
__slingshot_widgets_page_checker___lambda41__gtk_widget_destroy (GtkWidget* _sender,
                                                                 gpointer self)
{
#line 62 "../src/Widgets/PageChecker.vala"
	_slingshot_widgets_page_checker___lambda41_ ((SlingshotWidgetsPageChecker*) self);
#line 258 "PageChecker.c"
}

static GObject *
slingshot_widgets_page_checker_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotWidgetsPageChecker * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkCssProvider* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	HdyCarousel* _tmp7_;
	GList* _tmp8_;
	GList* _tmp9_;
	GtkWidget* _tmp10_;
	HdyCarousel* _tmp11_;
	GtkWidget* _tmp12_;
#line 43 "../src/Widgets/PageChecker.vala"
	parent_class = G_OBJECT_CLASS (slingshot_widgets_page_checker_parent_class);
#line 43 "../src/Widgets/PageChecker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../src/Widgets/PageChecker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_WIDGETS_TYPE_PAGE_CHECKER, SlingshotWidgetsPageChecker);
#line 44 "../src/Widgets/PageChecker.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 44 "../src/Widgets/PageChecker.vala"
	style_context = _tmp0_;
#line 45 "../src/Widgets/PageChecker.vala"
	_tmp1_ = style_context;
#line 45 "../src/Widgets/PageChecker.vala"
	gtk_style_context_add_class (_tmp1_, GTK_STYLE_CLASS_FLAT);
#line 46 "../src/Widgets/PageChecker.vala"
	_tmp2_ = style_context;
#line 46 "../src/Widgets/PageChecker.vala"
	gtk_style_context_add_class (_tmp2_, "switcher");
#line 47 "../src/Widgets/PageChecker.vala"
	_tmp3_ = style_context;
#line 47 "../src/Widgets/PageChecker.vala"
	_tmp4_ = slingshot_widgets_page_checker_provider;
#line 47 "../src/Widgets/PageChecker.vala"
	gtk_style_context_add_provider (_tmp3_, (GtkStyleProvider*) _tmp4_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 49 "../src/Widgets/PageChecker.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("pager-checked-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 49 "../src/Widgets/PageChecker.vala"
	g_object_ref_sink (_tmp5_);
#line 49 "../src/Widgets/PageChecker.vala"
	_tmp6_ = _tmp5_;
#line 49 "../src/Widgets/PageChecker.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp6_);
#line 49 "../src/Widgets/PageChecker.vala"
	_g_object_unref0 (_tmp6_);
#line 51 "../src/Widgets/PageChecker.vala"
	_tmp7_ = self->priv->_paginator;
#line 51 "../src/Widgets/PageChecker.vala"
	_tmp8_ = gtk_container_get_children ((GtkContainer*) _tmp7_);
#line 51 "../src/Widgets/PageChecker.vala"
	_tmp9_ = _tmp8_;
#line 51 "../src/Widgets/PageChecker.vala"
	_tmp10_ = self->priv->_page;
#line 51 "../src/Widgets/PageChecker.vala"
	self->priv->page_number = g_list_index (_tmp9_, _tmp10_);
#line 51 "../src/Widgets/PageChecker.vala"
	(_tmp9_ == NULL) ? NULL : (_tmp9_ = (g_list_free (_tmp9_), NULL));
#line 52 "../src/Widgets/PageChecker.vala"
	slingshot_widgets_page_checker_update_opacity (self);
#line 54 "../src/Widgets/PageChecker.vala"
	g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) __slingshot_widgets_page_checker___lambda39__gtk_button_clicked, self, 0);
#line 58 "../src/Widgets/PageChecker.vala"
	_tmp11_ = self->priv->_paginator;
#line 58 "../src/Widgets/PageChecker.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::position", (GCallback) __slingshot_widgets_page_checker___lambda40__g_object_notify, self, 0);
#line 62 "../src/Widgets/PageChecker.vala"
	_tmp12_ = self->priv->_page;
#line 62 "../src/Widgets/PageChecker.vala"
	g_signal_connect_object (_tmp12_, "destroy", (GCallback) __slingshot_widgets_page_checker___lambda41__gtk_widget_destroy, self, 0);
#line 43 "../src/Widgets/PageChecker.vala"
	return obj;
#line 343 "PageChecker.c"
}

static void
slingshot_widgets_page_checker_class_init (SlingshotWidgetsPageCheckerClass * klass,
                                           gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 22 "../src/Widgets/PageChecker.vala"
	slingshot_widgets_page_checker_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/PageChecker.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotWidgetsPageChecker_private_offset);
#line 22 "../src/Widgets/PageChecker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_widgets_page_checker_get_property;
#line 22 "../src/Widgets/PageChecker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_widgets_page_checker_set_property;
#line 22 "../src/Widgets/PageChecker.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_widgets_page_checker_constructor;
#line 22 "../src/Widgets/PageChecker.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_widgets_page_checker_finalize;
#line 22 "../src/Widgets/PageChecker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGINATOR_PROPERTY, slingshot_widgets_page_checker_properties[SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGINATOR_PROPERTY] = g_param_spec_object ("paginator", "paginator", "paginator", hdy_carousel_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/PageChecker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGE_PROPERTY, slingshot_widgets_page_checker_properties[SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 39 "../src/Widgets/PageChecker.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 39 "../src/Widgets/PageChecker.vala"
	_g_object_unref0 (slingshot_widgets_page_checker_provider);
#line 39 "../src/Widgets/PageChecker.vala"
	slingshot_widgets_page_checker_provider = _tmp0_;
#line 40 "../src/Widgets/PageChecker.vala"
	_tmp1_ = slingshot_widgets_page_checker_provider;
#line 40 "../src/Widgets/PageChecker.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/desktop/wingpanel/applications-menu/PageChecker.css");
#line 378 "PageChecker.c"
}

static void
slingshot_widgets_page_checker_instance_init (SlingshotWidgetsPageChecker * self,
                                              gpointer klass)
{
#line 22 "../src/Widgets/PageChecker.vala"
	self->priv = slingshot_widgets_page_checker_get_instance_private (self);
#line 387 "PageChecker.c"
}

static void
slingshot_widgets_page_checker_finalize (GObject * obj)
{
	SlingshotWidgetsPageChecker * self;
#line 22 "../src/Widgets/PageChecker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_WIDGETS_TYPE_PAGE_CHECKER, SlingshotWidgetsPageChecker);
#line 22 "../src/Widgets/PageChecker.vala"
	G_OBJECT_CLASS (slingshot_widgets_page_checker_parent_class)->finalize (obj);
#line 398 "PageChecker.c"
}

static GType
slingshot_widgets_page_checker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotWidgetsPageCheckerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_widgets_page_checker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotWidgetsPageChecker), 0, (GInstanceInitFunc) slingshot_widgets_page_checker_instance_init, NULL };
	GType slingshot_widgets_page_checker_type_id;
	slingshot_widgets_page_checker_type_id = g_type_register_static (gtk_button_get_type (), "SlingshotWidgetsPageChecker", &g_define_type_info, 0);
	SlingshotWidgetsPageChecker_private_offset = g_type_add_instance_private (slingshot_widgets_page_checker_type_id, sizeof (SlingshotWidgetsPageCheckerPrivate));
	return slingshot_widgets_page_checker_type_id;
}

GType
slingshot_widgets_page_checker_get_type (void)
{
	static volatile gsize slingshot_widgets_page_checker_type_id__once = 0;
	if (g_once_init_enter (&slingshot_widgets_page_checker_type_id__once)) {
		GType slingshot_widgets_page_checker_type_id;
		slingshot_widgets_page_checker_type_id = slingshot_widgets_page_checker_get_type_once ();
		g_once_init_leave (&slingshot_widgets_page_checker_type_id__once, slingshot_widgets_page_checker_type_id);
	}
	return slingshot_widgets_page_checker_type_id__once;
}

static void
_vala_slingshot_widgets_page_checker_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	SlingshotWidgetsPageChecker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_WIDGETS_TYPE_PAGE_CHECKER, SlingshotWidgetsPageChecker);
#line 22 "../src/Widgets/PageChecker.vala"
	switch (property_id) {
#line 22 "../src/Widgets/PageChecker.vala"
		case SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGINATOR_PROPERTY:
#line 22 "../src/Widgets/PageChecker.vala"
		g_value_set_object (value, slingshot_widgets_page_checker_get_paginator (self));
#line 22 "../src/Widgets/PageChecker.vala"
		break;
#line 22 "../src/Widgets/PageChecker.vala"
		case SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGE_PROPERTY:
#line 22 "../src/Widgets/PageChecker.vala"
		g_value_set_object (value, slingshot_widgets_page_checker_get_page (self));
#line 22 "../src/Widgets/PageChecker.vala"
		break;
#line 445 "PageChecker.c"
		default:
#line 22 "../src/Widgets/PageChecker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/PageChecker.vala"
		break;
#line 451 "PageChecker.c"
	}
}

static void
_vala_slingshot_widgets_page_checker_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	SlingshotWidgetsPageChecker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_WIDGETS_TYPE_PAGE_CHECKER, SlingshotWidgetsPageChecker);
#line 22 "../src/Widgets/PageChecker.vala"
	switch (property_id) {
#line 22 "../src/Widgets/PageChecker.vala"
		case SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGINATOR_PROPERTY:
#line 22 "../src/Widgets/PageChecker.vala"
		slingshot_widgets_page_checker_set_paginator (self, g_value_get_object (value));
#line 22 "../src/Widgets/PageChecker.vala"
		break;
#line 22 "../src/Widgets/PageChecker.vala"
		case SLINGSHOT_WIDGETS_PAGE_CHECKER_PAGE_PROPERTY:
#line 22 "../src/Widgets/PageChecker.vala"
		slingshot_widgets_page_checker_set_page (self, g_value_get_object (value));
#line 22 "../src/Widgets/PageChecker.vala"
		break;
#line 477 "PageChecker.c"
		default:
#line 22 "../src/Widgets/PageChecker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/PageChecker.vala"
		break;
#line 483 "PageChecker.c"
	}
}

