/* Match.c generated by valac 0.56.13, the Vala compiler
 * generated from Match.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*              Alberto Aldegheri <albyrock87+dev@gmail.com>
*/

#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	SYNAPSE_MATCH_0_PROPERTY,
	SYNAPSE_MATCH_TITLE_PROPERTY,
	SYNAPSE_MATCH_DESCRIPTION_PROPERTY,
	SYNAPSE_MATCH_ICON_NAME_PROPERTY,
	SYNAPSE_MATCH_HAS_THUMBNAIL_PROPERTY,
	SYNAPSE_MATCH_THUMBNAIL_PATH_PROPERTY,
	SYNAPSE_MATCH_MATCH_TYPE_PROPERTY,
	SYNAPSE_MATCH_NUM_PROPERTIES
};
static GParamSpec* synapse_match_properties[SYNAPSE_MATCH_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SYNAPSE_MATCH_EXECUTED_SIGNAL,
	SYNAPSE_MATCH_NUM_SIGNALS
};
static guint synapse_match_signals[SYNAPSE_MATCH_NUM_SIGNALS] = {0};

struct _SynapseMatchPrivate {
	gchar* _title;
	gchar* _description;
	gchar* _icon_name;
	gboolean _has_thumbnail;
	gchar* _thumbnail_path;
	SynapseMatchType _match_type;
};

static gint SynapseMatch_private_offset;
static gpointer synapse_match_parent_class = NULL;

static void synapse_match_real_execute (SynapseMatch* self,
                                 SynapseMatch* match);
static void synapse_match_real_execute_with_target (SynapseMatch* self,
                                             SynapseMatch* source,
                                             SynapseMatch* target);
static gboolean synapse_match_real_needs_target (SynapseMatch* self);
static SynapseQueryFlags synapse_match_real_target_flags (SynapseMatch* self);
static void synapse_match_finalize (GObject * obj);
static GType synapse_match_get_type_once (void);
static void _vala_synapse_match_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_synapse_match_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static GType
synapse_match_type_get_type_once (void)
{
	static const GEnumValue values[] = {{SYNAPSE_MATCH_TYPE_UNKNOWN, "SYNAPSE_MATCH_TYPE_UNKNOWN", "unknown"}, {SYNAPSE_MATCH_TYPE_TEXT, "SYNAPSE_MATCH_TYPE_TEXT", "text"}, {SYNAPSE_MATCH_TYPE_APPLICATION, "SYNAPSE_MATCH_TYPE_APPLICATION", "application"}, {SYNAPSE_MATCH_TYPE_BOOKMARK, "SYNAPSE_MATCH_TYPE_BOOKMARK", "bookmark"}, {SYNAPSE_MATCH_TYPE_GENERIC_URI, "SYNAPSE_MATCH_TYPE_GENERIC_URI", "generic-uri"}, {SYNAPSE_MATCH_TYPE_ACTION, "SYNAPSE_MATCH_TYPE_ACTION", "action"}, {SYNAPSE_MATCH_TYPE_SEARCH, "SYNAPSE_MATCH_TYPE_SEARCH", "search"}, {SYNAPSE_MATCH_TYPE_CONTACT, "SYNAPSE_MATCH_TYPE_CONTACT", "contact"}, {0, NULL, NULL}};
	GType synapse_match_type_type_id;
	synapse_match_type_type_id = g_enum_register_static ("SynapseMatchType", values);
	return synapse_match_type_type_id;
}

GType
synapse_match_type_get_type (void)
{
	static volatile gsize synapse_match_type_type_id__once = 0;
	if (g_once_init_enter (&synapse_match_type_type_id__once)) {
		GType synapse_match_type_type_id;
		synapse_match_type_type_id = synapse_match_type_get_type_once ();
		g_once_init_leave (&synapse_match_type_type_id__once, synapse_match_type_type_id);
	}
	return synapse_match_type_type_id__once;
}

static inline gpointer
synapse_match_get_instance_private (SynapseMatch* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseMatch_private_offset);
}

static GType
synapse_match_score_get_type_once (void)
{
	static const GEnumValue values[] = {{SYNAPSE_MATCH_SCORE_INCREMENT_MINOR, "SYNAPSE_MATCH_SCORE_INCREMENT_MINOR", "increment-minor"}, {SYNAPSE_MATCH_SCORE_INCREMENT_SMALL, "SYNAPSE_MATCH_SCORE_INCREMENT_SMALL", "increment-small"}, {SYNAPSE_MATCH_SCORE_INCREMENT_MEDIUM, "SYNAPSE_MATCH_SCORE_INCREMENT_MEDIUM", "increment-medium"}, {SYNAPSE_MATCH_SCORE_INCREMENT_LARGE, "SYNAPSE_MATCH_SCORE_INCREMENT_LARGE", "increment-large"}, {SYNAPSE_MATCH_SCORE_URI_PENALTY, "SYNAPSE_MATCH_SCORE_URI_PENALTY", "uri-penalty"}, {SYNAPSE_MATCH_SCORE_POOR, "SYNAPSE_MATCH_SCORE_POOR", "poor"}, {SYNAPSE_MATCH_SCORE_BELOW_AVERAGE, "SYNAPSE_MATCH_SCORE_BELOW_AVERAGE", "below-average"}, {SYNAPSE_MATCH_SCORE_AVERAGE, "SYNAPSE_MATCH_SCORE_AVERAGE", "average"}, {SYNAPSE_MATCH_SCORE_ABOVE_AVERAGE, "SYNAPSE_MATCH_SCORE_ABOVE_AVERAGE", "above-average"}, {SYNAPSE_MATCH_SCORE_GOOD, "SYNAPSE_MATCH_SCORE_GOOD", "good"}, {SYNAPSE_MATCH_SCORE_VERY_GOOD, "SYNAPSE_MATCH_SCORE_VERY_GOOD", "very-good"}, {SYNAPSE_MATCH_SCORE_EXCELLENT, "SYNAPSE_MATCH_SCORE_EXCELLENT", "excellent"}, {SYNAPSE_MATCH_SCORE_HIGHEST, "SYNAPSE_MATCH_SCORE_HIGHEST", "highest"}, {0, NULL, NULL}};
	GType synapse_match_score_type_id;
	synapse_match_score_type_id = g_enum_register_static ("SynapseMatchScore", values);
	return synapse_match_score_type_id;
}

GType
synapse_match_score_get_type (void)
{
	static volatile gsize synapse_match_score_type_id__once = 0;
	if (g_once_init_enter (&synapse_match_score_type_id__once)) {
		GType synapse_match_score_type_id;
		synapse_match_score_type_id = synapse_match_score_get_type_once ();
		g_once_init_leave (&synapse_match_score_type_id__once, synapse_match_score_type_id);
	}
	return synapse_match_score_type_id__once;
}

static void
synapse_match_real_execute (SynapseMatch* self,
                            SynapseMatch* match)
{
#line 63 "../src/synapse-core/Matches/Match.vala"
	g_critical ("Match.vala:63: execute () is not implemented");
#line 136 "Match.c"
}

void
synapse_match_execute (SynapseMatch* self,
                       SynapseMatch* match)
{
	SynapseMatchClass* _klass_;
#line 62 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/synapse-core/Matches/Match.vala"
	_klass_ = SYNAPSE_MATCH_GET_CLASS (self);
#line 62 "../src/synapse-core/Matches/Match.vala"
	if (_klass_->execute) {
#line 62 "../src/synapse-core/Matches/Match.vala"
		_klass_->execute (self, match);
#line 152 "Match.c"
	}
}

static void
synapse_match_real_execute_with_target (SynapseMatch* self,
                                        SynapseMatch* source,
                                        SynapseMatch* target)
{
#line 67 "../src/synapse-core/Matches/Match.vala"
	if (target == NULL) {
#line 68 "../src/synapse-core/Matches/Match.vala"
		synapse_match_execute (self, source);
#line 165 "Match.c"
	} else {
#line 70 "../src/synapse-core/Matches/Match.vala"
		g_critical ("Match.vala:70: execute () is not implemented");
#line 169 "Match.c"
	}
}

void
synapse_match_execute_with_target (SynapseMatch* self,
                                   SynapseMatch* source,
                                   SynapseMatch* target)
{
	SynapseMatchClass* _klass_;
#line 66 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/synapse-core/Matches/Match.vala"
	_klass_ = SYNAPSE_MATCH_GET_CLASS (self);
#line 66 "../src/synapse-core/Matches/Match.vala"
	if (_klass_->execute_with_target) {
#line 66 "../src/synapse-core/Matches/Match.vala"
		_klass_->execute_with_target (self, source, target);
#line 187 "Match.c"
	}
}

static gboolean
synapse_match_real_needs_target (SynapseMatch* self)
{
	gboolean result;
#line 75 "../src/synapse-core/Matches/Match.vala"
	result = FALSE;
#line 75 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 199 "Match.c"
}

gboolean
synapse_match_needs_target (SynapseMatch* self)
{
	SynapseMatchClass* _klass_;
#line 74 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 74 "../src/synapse-core/Matches/Match.vala"
	_klass_ = SYNAPSE_MATCH_GET_CLASS (self);
#line 74 "../src/synapse-core/Matches/Match.vala"
	if (_klass_->needs_target) {
#line 74 "../src/synapse-core/Matches/Match.vala"
		return _klass_->needs_target (self);
#line 214 "Match.c"
	}
#line 74 "../src/synapse-core/Matches/Match.vala"
	return FALSE;
#line 218 "Match.c"
}

static SynapseQueryFlags
synapse_match_real_target_flags (SynapseMatch* self)
{
	SynapseQueryFlags result;
#line 79 "../src/synapse-core/Matches/Match.vala"
	result = SYNAPSE_QUERY_FLAGS_ALL;
#line 79 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 229 "Match.c"
}

SynapseQueryFlags
synapse_match_target_flags (SynapseMatch* self)
{
	SynapseMatchClass* _klass_;
#line 78 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 78 "../src/synapse-core/Matches/Match.vala"
	_klass_ = SYNAPSE_MATCH_GET_CLASS (self);
#line 78 "../src/synapse-core/Matches/Match.vala"
	if (_klass_->target_flags) {
#line 78 "../src/synapse-core/Matches/Match.vala"
		return _klass_->target_flags (self);
#line 244 "Match.c"
	}
#line 78 "../src/synapse-core/Matches/Match.vala"
	return 0U;
#line 248 "Match.c"
}

SynapseMatch*
synapse_match_construct (GType object_type)
{
	SynapseMatch * self = NULL;
#line 35 "../src/synapse-core/Matches/Match.vala"
	self = (SynapseMatch*) g_object_new (object_type, NULL);
#line 35 "../src/synapse-core/Matches/Match.vala"
	return self;
#line 259 "Match.c"
}

const gchar*
synapse_match_get_title (SynapseMatch* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/synapse-core/Matches/Match.vala"
	_tmp0_ = self->priv->_title;
#line 55 "../src/synapse-core/Matches/Match.vala"
	result = _tmp0_;
#line 55 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 275 "Match.c"
}

void
synapse_match_set_title (SynapseMatch* self,
                         const gchar* value)
{
	gchar* old_value;
#line 55 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/synapse-core/Matches/Match.vala"
	old_value = synapse_match_get_title (self);
#line 55 "../src/synapse-core/Matches/Match.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 289 "Match.c"
		gchar* _tmp0_;
#line 55 "../src/synapse-core/Matches/Match.vala"
		_tmp0_ = g_strdup (value);
#line 55 "../src/synapse-core/Matches/Match.vala"
		_g_free0 (self->priv->_title);
#line 55 "../src/synapse-core/Matches/Match.vala"
		self->priv->_title = _tmp0_;
#line 55 "../src/synapse-core/Matches/Match.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_match_properties[SYNAPSE_MATCH_TITLE_PROPERTY]);
#line 299 "Match.c"
	}
}

const gchar*
synapse_match_get_description (SynapseMatch* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/synapse-core/Matches/Match.vala"
	_tmp0_ = self->priv->_description;
#line 56 "../src/synapse-core/Matches/Match.vala"
	result = _tmp0_;
#line 56 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 316 "Match.c"
}

void
synapse_match_set_description (SynapseMatch* self,
                               const gchar* value)
{
	gchar* old_value;
#line 56 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/synapse-core/Matches/Match.vala"
	old_value = synapse_match_get_description (self);
#line 56 "../src/synapse-core/Matches/Match.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 330 "Match.c"
		gchar* _tmp0_;
#line 56 "../src/synapse-core/Matches/Match.vala"
		_tmp0_ = g_strdup (value);
#line 56 "../src/synapse-core/Matches/Match.vala"
		_g_free0 (self->priv->_description);
#line 56 "../src/synapse-core/Matches/Match.vala"
		self->priv->_description = _tmp0_;
#line 56 "../src/synapse-core/Matches/Match.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_match_properties[SYNAPSE_MATCH_DESCRIPTION_PROPERTY]);
#line 340 "Match.c"
	}
}

const gchar*
synapse_match_get_icon_name (SynapseMatch* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 57 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/synapse-core/Matches/Match.vala"
	_tmp0_ = self->priv->_icon_name;
#line 57 "../src/synapse-core/Matches/Match.vala"
	result = _tmp0_;
#line 57 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 357 "Match.c"
}

void
synapse_match_set_icon_name (SynapseMatch* self,
                             const gchar* value)
{
	gchar* old_value;
#line 57 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/synapse-core/Matches/Match.vala"
	old_value = synapse_match_get_icon_name (self);
#line 57 "../src/synapse-core/Matches/Match.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 371 "Match.c"
		gchar* _tmp0_;
#line 57 "../src/synapse-core/Matches/Match.vala"
		_tmp0_ = g_strdup (value);
#line 57 "../src/synapse-core/Matches/Match.vala"
		_g_free0 (self->priv->_icon_name);
#line 57 "../src/synapse-core/Matches/Match.vala"
		self->priv->_icon_name = _tmp0_;
#line 57 "../src/synapse-core/Matches/Match.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_match_properties[SYNAPSE_MATCH_ICON_NAME_PROPERTY]);
#line 381 "Match.c"
	}
}

gboolean
synapse_match_get_has_thumbnail (SynapseMatch* self)
{
	gboolean result;
#line 58 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../src/synapse-core/Matches/Match.vala"
	result = self->priv->_has_thumbnail;
#line 58 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 395 "Match.c"
}

void
synapse_match_set_has_thumbnail (SynapseMatch* self,
                                 gboolean value)
{
	gboolean old_value;
#line 58 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/synapse-core/Matches/Match.vala"
	old_value = synapse_match_get_has_thumbnail (self);
#line 58 "../src/synapse-core/Matches/Match.vala"
	if (old_value != value) {
#line 58 "../src/synapse-core/Matches/Match.vala"
		self->priv->_has_thumbnail = value;
#line 58 "../src/synapse-core/Matches/Match.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_match_properties[SYNAPSE_MATCH_HAS_THUMBNAIL_PROPERTY]);
#line 413 "Match.c"
	}
}

const gchar*
synapse_match_get_thumbnail_path (SynapseMatch* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/synapse-core/Matches/Match.vala"
	_tmp0_ = self->priv->_thumbnail_path;
#line 59 "../src/synapse-core/Matches/Match.vala"
	result = _tmp0_;
#line 59 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 430 "Match.c"
}

void
synapse_match_set_thumbnail_path (SynapseMatch* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 59 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/synapse-core/Matches/Match.vala"
	old_value = synapse_match_get_thumbnail_path (self);
#line 59 "../src/synapse-core/Matches/Match.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 444 "Match.c"
		gchar* _tmp0_;
#line 59 "../src/synapse-core/Matches/Match.vala"
		_tmp0_ = g_strdup (value);
#line 59 "../src/synapse-core/Matches/Match.vala"
		_g_free0 (self->priv->_thumbnail_path);
#line 59 "../src/synapse-core/Matches/Match.vala"
		self->priv->_thumbnail_path = _tmp0_;
#line 59 "../src/synapse-core/Matches/Match.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_match_properties[SYNAPSE_MATCH_THUMBNAIL_PATH_PROPERTY]);
#line 454 "Match.c"
	}
}

SynapseMatchType
synapse_match_get_match_type (SynapseMatch* self)
{
	SynapseMatchType result;
#line 60 "../src/synapse-core/Matches/Match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/synapse-core/Matches/Match.vala"
	result = self->priv->_match_type;
#line 60 "../src/synapse-core/Matches/Match.vala"
	return result;
#line 468 "Match.c"
}

void
synapse_match_set_match_type (SynapseMatch* self,
                              SynapseMatchType value)
{
	SynapseMatchType old_value;
#line 60 "../src/synapse-core/Matches/Match.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/synapse-core/Matches/Match.vala"
	old_value = synapse_match_get_match_type (self);
#line 60 "../src/synapse-core/Matches/Match.vala"
	if (old_value != value) {
#line 60 "../src/synapse-core/Matches/Match.vala"
		self->priv->_match_type = value;
#line 60 "../src/synapse-core/Matches/Match.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_match_properties[SYNAPSE_MATCH_MATCH_TYPE_PROPERTY]);
#line 486 "Match.c"
	}
}

static void
synapse_match_class_init (SynapseMatchClass * klass,
                          gpointer klass_data)
{
#line 35 "../src/synapse-core/Matches/Match.vala"
	synapse_match_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_type_class_adjust_private_offset (klass, &SynapseMatch_private_offset);
#line 35 "../src/synapse-core/Matches/Match.vala"
	((SynapseMatchClass *) klass)->execute = (void (*) (SynapseMatch*, SynapseMatch*)) synapse_match_real_execute;
#line 35 "../src/synapse-core/Matches/Match.vala"
	((SynapseMatchClass *) klass)->execute_with_target = (void (*) (SynapseMatch*, SynapseMatch*, SynapseMatch*)) synapse_match_real_execute_with_target;
#line 35 "../src/synapse-core/Matches/Match.vala"
	((SynapseMatchClass *) klass)->needs_target = (gboolean (*) (SynapseMatch*)) synapse_match_real_needs_target;
#line 35 "../src/synapse-core/Matches/Match.vala"
	((SynapseMatchClass *) klass)->target_flags = (SynapseQueryFlags (*) (SynapseMatch*)) synapse_match_real_target_flags;
#line 35 "../src/synapse-core/Matches/Match.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_synapse_match_get_property;
#line 35 "../src/synapse-core/Matches/Match.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_synapse_match_set_property;
#line 35 "../src/synapse-core/Matches/Match.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_match_finalize;
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_MATCH_TITLE_PROPERTY, synapse_match_properties[SYNAPSE_MATCH_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_MATCH_DESCRIPTION_PROPERTY, synapse_match_properties[SYNAPSE_MATCH_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_MATCH_ICON_NAME_PROPERTY, synapse_match_properties[SYNAPSE_MATCH_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_MATCH_HAS_THUMBNAIL_PROPERTY, synapse_match_properties[SYNAPSE_MATCH_HAS_THUMBNAIL_PROPERTY] = g_param_spec_boolean ("has-thumbnail", "has-thumbnail", "has-thumbnail", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_MATCH_THUMBNAIL_PATH_PROPERTY, synapse_match_properties[SYNAPSE_MATCH_THUMBNAIL_PATH_PROPERTY] = g_param_spec_string ("thumbnail-path", "thumbnail-path", "thumbnail-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../src/synapse-core/Matches/Match.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_MATCH_MATCH_TYPE_PROPERTY, synapse_match_properties[SYNAPSE_MATCH_MATCH_TYPE_PROPERTY] = g_param_spec_enum ("match-type", "match-type", "match-type", SYNAPSE_TYPE_MATCH_TYPE, SYNAPSE_MATCH_TYPE_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../src/synapse-core/Matches/Match.vala"
	synapse_match_signals[SYNAPSE_MATCH_EXECUTED_SIGNAL] = g_signal_new ("executed", SYNAPSE_TYPE_MATCH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 526 "Match.c"
}

static void
synapse_match_instance_init (SynapseMatch * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 35 "../src/synapse-core/Matches/Match.vala"
	self->priv = synapse_match_get_instance_private (self);
#line 55 "../src/synapse-core/Matches/Match.vala"
	_tmp0_ = g_strdup ("");
#line 55 "../src/synapse-core/Matches/Match.vala"
	self->priv->_title = _tmp0_;
#line 56 "../src/synapse-core/Matches/Match.vala"
	_tmp1_ = g_strdup ("");
#line 56 "../src/synapse-core/Matches/Match.vala"
	self->priv->_description = _tmp1_;
#line 57 "../src/synapse-core/Matches/Match.vala"
	self->priv->_icon_name = NULL;
#line 58 "../src/synapse-core/Matches/Match.vala"
	self->priv->_has_thumbnail = FALSE;
#line 59 "../src/synapse-core/Matches/Match.vala"
	self->priv->_thumbnail_path = NULL;
#line 60 "../src/synapse-core/Matches/Match.vala"
	self->priv->_match_type = SYNAPSE_MATCH_TYPE_UNKNOWN;
#line 553 "Match.c"
}

static void
synapse_match_finalize (GObject * obj)
{
	SynapseMatch * self;
#line 35 "../src/synapse-core/Matches/Match.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_MATCH, SynapseMatch);
#line 55 "../src/synapse-core/Matches/Match.vala"
	_g_free0 (self->priv->_title);
#line 56 "../src/synapse-core/Matches/Match.vala"
	_g_free0 (self->priv->_description);
#line 57 "../src/synapse-core/Matches/Match.vala"
	_g_free0 (self->priv->_icon_name);
#line 59 "../src/synapse-core/Matches/Match.vala"
	_g_free0 (self->priv->_thumbnail_path);
#line 35 "../src/synapse-core/Matches/Match.vala"
	G_OBJECT_CLASS (synapse_match_parent_class)->finalize (obj);
#line 572 "Match.c"
}

static GType
synapse_match_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseMatchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_match_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseMatch), 0, (GInstanceInitFunc) synapse_match_instance_init, NULL };
	GType synapse_match_type_id;
	synapse_match_type_id = g_type_register_static (G_TYPE_OBJECT, "SynapseMatch", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SynapseMatch_private_offset = g_type_add_instance_private (synapse_match_type_id, sizeof (SynapseMatchPrivate));
	return synapse_match_type_id;
}

GType
synapse_match_get_type (void)
{
	static volatile gsize synapse_match_type_id__once = 0;
	if (g_once_init_enter (&synapse_match_type_id__once)) {
		GType synapse_match_type_id;
		synapse_match_type_id = synapse_match_get_type_once ();
		g_once_init_leave (&synapse_match_type_id__once, synapse_match_type_id);
	}
	return synapse_match_type_id__once;
}

static void
_vala_synapse_match_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SynapseMatch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_MATCH, SynapseMatch);
#line 35 "../src/synapse-core/Matches/Match.vala"
	switch (property_id) {
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_TITLE_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		g_value_set_string (value, synapse_match_get_title (self));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_DESCRIPTION_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		g_value_set_string (value, synapse_match_get_description (self));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_ICON_NAME_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		g_value_set_string (value, synapse_match_get_icon_name (self));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_HAS_THUMBNAIL_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		g_value_set_boolean (value, synapse_match_get_has_thumbnail (self));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_THUMBNAIL_PATH_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		g_value_set_string (value, synapse_match_get_thumbnail_path (self));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_MATCH_TYPE_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		g_value_set_enum (value, synapse_match_get_match_type (self));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 643 "Match.c"
		default:
#line 35 "../src/synapse-core/Matches/Match.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 649 "Match.c"
	}
}

static void
_vala_synapse_match_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SynapseMatch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_MATCH, SynapseMatch);
#line 35 "../src/synapse-core/Matches/Match.vala"
	switch (property_id) {
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_TITLE_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		synapse_match_set_title (self, g_value_get_string (value));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_DESCRIPTION_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		synapse_match_set_description (self, g_value_get_string (value));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_ICON_NAME_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		synapse_match_set_icon_name (self, g_value_get_string (value));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_HAS_THUMBNAIL_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		synapse_match_set_has_thumbnail (self, g_value_get_boolean (value));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_THUMBNAIL_PATH_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		synapse_match_set_thumbnail_path (self, g_value_get_string (value));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 35 "../src/synapse-core/Matches/Match.vala"
		case SYNAPSE_MATCH_MATCH_TYPE_PROPERTY:
#line 35 "../src/synapse-core/Matches/Match.vala"
		synapse_match_set_match_type (self, g_value_get_enum (value));
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 699 "Match.c"
		default:
#line 35 "../src/synapse-core/Matches/Match.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/synapse-core/Matches/Match.vala"
		break;
#line 705 "Match.c"
	}
}

