/* converter-plugin-backend.c generated by valac 0.56.13, the Vala compiler
 * generated from converter-plugin-backend.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2022 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include "slingshot.h"

#define SYNAPSE_MASS "unit of mass"
#define SYNAPSE_LENGTH "unit of length"
#define SYNAPSE_AREA "unit of area"
#define SYNAPSE_VOLUME "unit of volume"
#define SYNAPSE_TIME "unit of time"
#define SYNAPSE_VELOCITY "unit of velocity"

#define SYNAPSE_TYPE_UNIT_MATCH (synapse_unit_match_get_type ())
typedef struct _SynapseUnitMatch SynapseUnitMatch;

#define SYNAPSE_TYPE_UNIT (synapse_unit_get_type ())
typedef struct _SynapseUnit SynapseUnit;
typedef enum  {
	SYNAPSE_UNIT_TYPE_MASS,
	SYNAPSE_UNIT_TYPE_DIMENSION,
	SYNAPSE_UNIT_TYPE_TIME,
	SYNAPSE_UNIT_TYPE_VELOCITY
} SynapseUnitType;

#define SYNAPSE_TYPE_UNIT_TYPE (synapse_unit_type_get_type ())
typedef enum  {
	SYNAPSE_UNIT_SYSTEM_SI,
	SYNAPSE_UNIT_SYSTEM_IMPERIAL,
	SYNAPSE_UNIT_SYSTEM_IMPERIAL_UK,
	SYNAPSE_UNIT_SYSTEM_IMPERIAL_US
} SynapseUnitSystem;

#define SYNAPSE_TYPE_UNIT_SYSTEM (synapse_unit_system_get_type ())

#define SYNAPSE_TYPE_SI_PREFIX (synapse_si_prefix_get_type ())
typedef struct _SynapseSIPrefix SynapseSIPrefix;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SYNAPSE_CONVERTER_PLUGIN_BACKEND_0_PROPERTY,
	SYNAPSE_CONVERTER_PLUGIN_BACKEND_NUM_PROPERTIES
};
static GParamSpec* synapse_converter_plugin_backend_properties[SYNAPSE_CONVERTER_PLUGIN_BACKEND_NUM_PROPERTIES];
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _synapse_result_data_free0(var) ((var == NULL) ? NULL : (var = (synapse_result_data_free (var), NULL)))
#define _synapse_unit_free0(var) ((var == NULL) ? NULL : (var = (synapse_unit_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SynapseUnit {
	SynapseUnitType type;
	SynapseUnitSystem system;
	gchar* uid;
	gchar* abbreviations;
	gchar* description;
	gchar* size_s;
	gchar* base_unit;
};

struct _SynapseSIPrefix {
	gchar* prefix;
	gchar* abbrev;
	gdouble factor;
};

struct _SynapseUnitMatch {
	SynapseUnit unit;
	SynapseSIPrefix prefix;
	gint dimension;
};

struct _SynapseConverterPluginBackendPrivate {
	GRegex* convert_regex;
};

static gint SynapseConverterPluginBackend_private_offset;
static gpointer synapse_converter_plugin_backend_parent_class = NULL;
static SynapseConverterPluginBackend* synapse_converter_plugin_backend_instance;
static SynapseConverterPluginBackend* synapse_converter_plugin_backend_instance = NULL;

VALA_EXTERN GType synapse_unit_match_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType synapse_unit_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType synapse_unit_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType synapse_unit_system_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SynapseUnit* synapse_unit_dup (const SynapseUnit* self);
VALA_EXTERN void synapse_unit_free (SynapseUnit* self);
VALA_EXTERN void synapse_unit_copy (const SynapseUnit* self,
                        SynapseUnit* dest);
VALA_EXTERN void synapse_unit_destroy (SynapseUnit* self);
VALA_EXTERN GType synapse_si_prefix_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SynapseSIPrefix* synapse_si_prefix_dup (const SynapseSIPrefix* self);
VALA_EXTERN void synapse_si_prefix_free (SynapseSIPrefix* self);
VALA_EXTERN void synapse_si_prefix_copy (const SynapseSIPrefix* self,
                             SynapseSIPrefix* dest);
VALA_EXTERN void synapse_si_prefix_destroy (SynapseSIPrefix* self);
VALA_EXTERN SynapseUnitMatch* synapse_unit_match_dup (const SynapseUnitMatch* self);
VALA_EXTERN void synapse_unit_match_free (SynapseUnitMatch* self);
VALA_EXTERN void synapse_unit_match_copy (const SynapseUnitMatch* self,
                              SynapseUnitMatch* dest);
VALA_EXTERN void synapse_unit_match_destroy (SynapseUnitMatch* self);
VALA_EXTERN gchar* synapse_unit_match_description (SynapseUnitMatch *self);
VALA_EXTERN gdouble synapse_unit_match_factor (SynapseUnitMatch *self);
VALA_EXTERN gdouble synapse_unit_get_factor (SynapseUnit *self);
VALA_EXTERN void synapse_si_prefix_get_default (SynapseSIPrefix* result);
static void synapse_converter_plugin_backend_get_prefix (SynapseConverterPluginBackend* self,
                                                  const gchar* unit_s,
                                                  gchar** prefix_s,
                                                  SynapseSIPrefix* prefix);
static gboolean synapse_converter_plugin_backend_check_match (SynapseConverterPluginBackend* self,
                                                       SynapseUnit* u,
                                                       const gchar* unit_s,
                                                       const gchar* prefix,
                                                       gint dimension,
                                                       gboolean* use_prefix);
static void _vala_array_add11 (SynapseUnitMatch* * array,
                        gint* length,
                        gint* size,
                        const SynapseUnitMatch* value);
static void _vala_array_add12 (SynapseUnitMatch* * array,
                        gint* length,
                        gint* size,
                        const SynapseUnitMatch* value);
static SynapseResultData* synapse_converter_plugin_backend_calculate_conversion_data (SynapseConverterPluginBackend* self,
                                                                               gdouble num,
                                                                               SynapseUnitMatch* match1,
                                                                               SynapseUnitMatch* match2);
static void _vala_array_add13 (SynapseResultData* * array,
                        gint* length,
                        gint* size,
                        const SynapseResultData* value);
static void _vala_SynapseUnitMatch_array_free (SynapseUnitMatch * array,
                                        gssize array_length);
static void synapse_converter_plugin_backend_find_root (SynapseConverterPluginBackend* self,
                                                 SynapseUnit** parent,
                                                 gint* dim,
                                                 gdouble* factor,
                                                 gboolean same_system,
                                                 SynapseUnitSystem match_unit_system);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static GObject * synapse_converter_plugin_backend_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties);
static void synapse_converter_plugin_backend_finalize (GObject * obj);
static GType synapse_converter_plugin_backend_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const SynapseUnit SYNAPSE_UNITS[75];
VALA_EXTERN const SynapseSIPrefix SYNAPSE_PREFIXES[20];

gchar*
synapse_unit_match_description (SynapseUnitMatch *self)
{
	gchar* dim = NULL;
	gchar* _tmp0_;
	SynapseSIPrefix _tmp3_;
	const gchar* _tmp4_;
	SynapseUnit _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 30 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = g_strdup ("");
#line 30 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dim = _tmp0_;
#line 31 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if ((*self).dimension == 2) {
#line 211 "converter-plugin-backend.c"
		gchar* _tmp1_;
#line 32 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp1_ = g_strdup (_ ("squared"));
#line 32 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (dim);
#line 32 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		dim = _tmp1_;
#line 219 "converter-plugin-backend.c"
	} else {
#line 33 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if ((*self).dimension == 3) {
#line 223 "converter-plugin-backend.c"
			gchar* _tmp2_;
#line 34 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp2_ = g_strdup (_ ("cubed"));
#line 34 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_g_free0 (dim);
#line 34 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			dim = _tmp2_;
#line 231 "converter-plugin-backend.c"
		}
	}
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = (*self).prefix;
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp4_ = _tmp3_.prefix;
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp5_ = (*self).unit;
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp6_ = _tmp5_.description;
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp7_ = dim;
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp8_ = g_strdup_printf (_ ("%s%s %s"), _tmp4_, _tmp6_, _tmp7_);
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	result = _tmp8_;
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (dim);
#line 38 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return result;
#line 252 "converter-plugin-backend.c"
}

gdouble
synapse_unit_match_factor (SynapseUnitMatch *self)
{
	gdouble factor = 0.0;
	gdouble size = 0.0;
	gdouble result;
#line 42 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	factor = 1.0;
#line 43 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	size = synapse_unit_get_factor (&(*self).unit);
#line 265 "converter-plugin-backend.c"
	{
		gint i = 0;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		i = 0;
#line 270 "converter-plugin-backend.c"
		{
			gboolean _tmp0_ = FALSE;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp0_ = TRUE;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			while (TRUE) {
#line 277 "converter-plugin-backend.c"
				SynapseSIPrefix _tmp2_;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				if (!_tmp0_) {
#line 281 "converter-plugin-backend.c"
					gint _tmp1_;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp1_ = i;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					i = _tmp1_ + 1;
#line 287 "converter-plugin-backend.c"
				}
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp0_ = FALSE;
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				if (!(i < (*self).dimension)) {
#line 44 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					break;
#line 295 "converter-plugin-backend.c"
				}
#line 45 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp2_ = (*self).prefix;
#line 45 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				factor *= _tmp2_.factor;
#line 46 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				factor *= size;
#line 303 "converter-plugin-backend.c"
			}
		}
	}
#line 49 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	result = factor;
#line 49 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return result;
#line 311 "converter-plugin-backend.c"
}

void
synapse_unit_match_copy (const SynapseUnitMatch* self,
                         SynapseUnitMatch* dest)
{
	SynapseUnit _tmp0_;
	SynapseUnit _tmp1_;
	SynapseUnit _tmp2_ = {0};
	SynapseSIPrefix _tmp3_;
	SynapseSIPrefix _tmp4_;
	SynapseSIPrefix _tmp5_ = {0};
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = (*self).unit;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp1_ = _tmp0_;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_copy (&_tmp1_, &_tmp2_);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_destroy (&(*dest).unit);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*dest).unit = _tmp2_;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = (*self).prefix;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp4_ = _tmp3_;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_copy (&_tmp4_, &_tmp5_);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_destroy (&(*dest).prefix);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*dest).prefix = _tmp5_;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*dest).dimension = (*self).dimension;
#line 346 "converter-plugin-backend.c"
}

void
synapse_unit_match_destroy (SynapseUnitMatch* self)
{
#line 25 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_destroy (&(*self).unit);
#line 26 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_destroy (&(*self).prefix);
#line 356 "converter-plugin-backend.c"
}

SynapseUnitMatch*
synapse_unit_match_dup (const SynapseUnitMatch* self)
{
	SynapseUnitMatch* dup;
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dup = g_new0 (SynapseUnitMatch, 1);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_match_copy (self, dup);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return dup;
#line 369 "converter-plugin-backend.c"
}

void
synapse_unit_match_free (SynapseUnitMatch* self)
{
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_match_destroy (self);
#line 24 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_free (self);
#line 379 "converter-plugin-backend.c"
}

static GType
synapse_unit_match_get_type_once (void)
{
	GType synapse_unit_match_type_id;
	synapse_unit_match_type_id = g_boxed_type_register_static ("SynapseUnitMatch", (GBoxedCopyFunc) synapse_unit_match_dup, (GBoxedFreeFunc) synapse_unit_match_free);
	return synapse_unit_match_type_id;
}

GType
synapse_unit_match_get_type (void)
{
	static volatile gsize synapse_unit_match_type_id__once = 0;
	if (g_once_init_enter (&synapse_unit_match_type_id__once)) {
		GType synapse_unit_match_type_id;
		synapse_unit_match_type_id = synapse_unit_match_get_type_once ();
		g_once_init_leave (&synapse_unit_match_type_id__once, synapse_unit_match_type_id);
	}
	return synapse_unit_match_type_id__once;
}

void
synapse_result_data_copy (const SynapseResultData* self,
                          SynapseResultData* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*dest).factor = (*self).factor;
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = (*self).from_description;
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 ((*dest).from_description);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*dest).from_description = _tmp1_;
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp2_ = (*self).to_description;
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 ((*dest).to_description);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*dest).to_description = _tmp3_;
#line 428 "converter-plugin-backend.c"
}

void
synapse_result_data_destroy (SynapseResultData* self)
{
#line 55 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 ((*self).from_description);
#line 56 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 ((*self).to_description);
#line 438 "converter-plugin-backend.c"
}

SynapseResultData*
synapse_result_data_dup (const SynapseResultData* self)
{
	SynapseResultData* dup;
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dup = g_new0 (SynapseResultData, 1);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_result_data_copy (self, dup);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return dup;
#line 451 "converter-plugin-backend.c"
}

void
synapse_result_data_free (SynapseResultData* self)
{
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_result_data_destroy (self);
#line 53 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_free (self);
#line 461 "converter-plugin-backend.c"
}

static GType
synapse_result_data_get_type_once (void)
{
	GType synapse_result_data_type_id;
	synapse_result_data_type_id = g_boxed_type_register_static ("SynapseResultData", (GBoxedCopyFunc) synapse_result_data_dup, (GBoxedFreeFunc) synapse_result_data_free);
	return synapse_result_data_type_id;
}

GType
synapse_result_data_get_type (void)
{
	static volatile gsize synapse_result_data_type_id__once = 0;
	if (g_once_init_enter (&synapse_result_data_type_id__once)) {
		GType synapse_result_data_type_id;
		synapse_result_data_type_id = synapse_result_data_get_type_once ();
		g_once_init_leave (&synapse_result_data_type_id__once, synapse_result_data_type_id);
	}
	return synapse_result_data_type_id__once;
}

static inline gpointer
synapse_converter_plugin_backend_get_instance_private (SynapseConverterPluginBackend* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseConverterPluginBackend_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 65 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return self ? g_object_ref (self) : NULL;
#line 495 "converter-plugin-backend.c"
}

SynapseConverterPluginBackend*
synapse_converter_plugin_backend_get_instance (void)
{
	SynapseConverterPluginBackend* _tmp0_;
	SynapseConverterPluginBackend* _tmp2_;
	SynapseConverterPluginBackend* _tmp3_;
	SynapseConverterPluginBackend* result;
#line 61 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = synapse_converter_plugin_backend_instance;
#line 61 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp0_ == NULL) {
#line 509 "converter-plugin-backend.c"
		SynapseConverterPluginBackend* _tmp1_;
#line 62 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp1_ = synapse_converter_plugin_backend_new ();
#line 62 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_object_unref0 (synapse_converter_plugin_backend_instance);
#line 62 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_converter_plugin_backend_instance = _tmp1_;
#line 517 "converter-plugin-backend.c"
	}
#line 65 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp2_ = synapse_converter_plugin_backend_instance;
#line 65 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 65 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	result = _tmp3_;
#line 65 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return result;
#line 527 "converter-plugin-backend.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 546 "converter-plugin-backend.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 568 "converter-plugin-backend.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 572 "converter-plugin-backend.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 578 "converter-plugin-backend.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 582 "converter-plugin-backend.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 586 "converter-plugin-backend.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 594 "converter-plugin-backend.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 622 "converter-plugin-backend.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 631 "converter-plugin-backend.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 645 "converter-plugin-backend.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 654 "converter-plugin-backend.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 668 "converter-plugin-backend.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 677 "converter-plugin-backend.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 686 "converter-plugin-backend.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 699 "converter-plugin-backend.c"
}

static void
_vala_array_add11 (SynapseUnitMatch* * array,
                   gint* length,
                   gint* size,
                   const SynapseUnitMatch* value)
{
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if ((*length) == (*size)) {
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*array = g_renew (SynapseUnitMatch, *array, *size);
#line 714 "converter-plugin-backend.c"
	}
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[(*length)++] = *value;
#line 718 "converter-plugin-backend.c"
}

static void
_vala_array_add12 (SynapseUnitMatch* * array,
                   gint* length,
                   gint* size,
                   const SynapseUnitMatch* value)
{
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if ((*length) == (*size)) {
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*array = g_renew (SynapseUnitMatch, *array, *size);
#line 733 "converter-plugin-backend.c"
	}
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[(*length)++] = *value;
#line 737 "converter-plugin-backend.c"
}

static void
_vala_array_add13 (SynapseResultData* * array,
                   gint* length,
                   gint* size,
                   const SynapseResultData* value)
{
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if ((*length) == (*size)) {
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*array = g_renew (SynapseResultData, *array, *size);
#line 752 "converter-plugin-backend.c"
	}
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[(*length)++] = *value;
#line 756 "converter-plugin-backend.c"
}

static void
_vala_SynapseUnitMatch_array_free (SynapseUnitMatch * array,
                                   gssize array_length)
{
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (array != NULL) {
#line 765 "converter-plugin-backend.c"
		gssize i;
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			synapse_unit_match_destroy (&array[i]);
#line 771 "converter-plugin-backend.c"
		}
	}
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_free (array);
#line 776 "converter-plugin-backend.c"
}

SynapseResultData*
synapse_converter_plugin_backend_get_conversion_data (SynapseConverterPluginBackend* self,
                                                      const gchar* query_string,
                                                      gint* result_length1)
{
	SynapseResultData* results = NULL;
	SynapseResultData* _tmp0_;
	gint results_length1;
	gint _results_size_;
	gboolean _tmp1_ = FALSE;
	gchar* input = NULL;
	gchar* _tmp3_;
	GMatchInfo* match_info = NULL;
	gboolean matched = FALSE;
	GRegex* _tmp4_;
	const gchar* _tmp5_;
	GMatchInfo* _tmp6_ = NULL;
	gboolean _tmp7_;
	gdouble num = 0.0;
	SynapseUnitMatch* match_arr1 = NULL;
	SynapseUnitMatch* _tmp8_;
	gint match_arr1_length1;
	gint _match_arr1_size_;
	SynapseUnitMatch* match_arr2 = NULL;
	SynapseUnitMatch* _tmp9_;
	gint match_arr2_length1;
	gint _match_arr2_size_;
	SynapseSIPrefix prefix1 = {0};
	SynapseSIPrefix _tmp10_ = {0};
	SynapseSIPrefix prefix2 = {0};
	SynapseSIPrefix _tmp11_ = {0};
	gchar* prefix1_s = NULL;
	gchar* _tmp12_;
	gchar* prefix2_s = NULL;
	gchar* _tmp13_;
	gint dimension1 = 0;
	gint dimension2 = 0;
	gboolean use_prefix = FALSE;
	SynapseUnitMatch* _tmp72_;
	gint _tmp72__length1;
	SynapseUnitMatch* _tmp73_;
	gint _tmp73__length1;
	SynapseResultData* _tmp97_;
	gint _tmp97__length1;
	SynapseResultData* result;
#line 88 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (query_string != NULL, NULL);
#line 89 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = g_new0 (SynapseResultData, 0);
#line 89 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	results = _tmp0_;
#line 89 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	results_length1 = 0;
#line 89 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_results_size_ = results_length1;
#line 90 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (string_contains (query_string, "=>")) {
#line 90 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp1_ = TRUE;
#line 840 "converter-plugin-backend.c"
	} else {
#line 90 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp1_ = string_contains (query_string, "->");
#line 844 "converter-plugin-backend.c"
	}
#line 90 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (!_tmp1_) {
#line 848 "converter-plugin-backend.c"
		SynapseResultData* _tmp2_;
		gint _tmp2__length1;
#line 91 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp2_ = results;
#line 91 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp2__length1 = results_length1;
#line 91 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if (result_length1) {
#line 91 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			*result_length1 = _tmp2__length1;
#line 859 "converter-plugin-backend.c"
		}
#line 91 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		result = _tmp2_;
#line 91 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		return result;
#line 865 "converter-plugin-backend.c"
	}
#line 94 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = string_replace (query_string, ",", ".");
#line 94 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	input = _tmp3_;
#line 95 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_info = NULL;
#line 96 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp4_ = self->priv->convert_regex;
#line 96 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp5_ = input;
#line 96 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp7_ = g_regex_match (_tmp4_, _tmp5_, 0, &_tmp6_);
#line 96 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_match_info_unref0 (match_info);
#line 96 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_info = _tmp6_;
#line 96 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	matched = _tmp7_;
#line 97 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	num = 1.0;
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp8_ = g_new0 (SynapseUnitMatch, 0);
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_arr1 = _tmp8_;
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_arr1_length1 = 0;
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_match_arr1_size_ = match_arr1_length1;
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp9_ = g_new0 (SynapseUnitMatch, 0);
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_arr2 = _tmp9_;
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_arr2_length1 = 0;
#line 98 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_match_arr2_size_ = match_arr2_length1;
#line 99 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_get_default (&_tmp10_);
#line 99 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	prefix1 = _tmp10_;
#line 99 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_get_default (&_tmp11_);
#line 99 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	prefix2 = _tmp11_;
#line 100 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp12_ = g_strdup ("");
#line 100 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	prefix1_s = _tmp12_;
#line 100 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp13_ = g_strdup ("");
#line 100 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	prefix2_s = _tmp13_;
#line 101 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dimension1 = 1;
#line 101 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dimension2 = 1;
#line 102 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	use_prefix = FALSE;
#line 104 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (matched) {
#line 927 "converter-plugin-backend.c"
		GMatchInfo* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gdouble _tmp17_ = 0.0;
		gchar* unit1_s = NULL;
		GMatchInfo* _tmp18_;
		gchar* _tmp19_;
		GMatchInfo* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* unit2_s = NULL;
		GMatchInfo* _tmp23_;
		gchar* _tmp24_;
		GMatchInfo* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_ = NULL;
		SynapseSIPrefix _tmp30_ = {0};
		const gchar* _tmp31_;
		gchar* _tmp32_ = NULL;
		SynapseSIPrefix _tmp33_ = {0};
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
#line 106 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp14_ = match_info;
#line 106 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp15_ = g_match_info_fetch (_tmp14_, 1);
#line 106 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp16_ = _tmp15_;
#line 106 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		num = double_parse (_tmp16_);
#line 106 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (_tmp16_);
#line 107 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if (num == ((gdouble) 0)) {
#line 107 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp17_ = 1.0;
#line 968 "converter-plugin-backend.c"
		} else {
#line 107 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp17_ = num;
#line 972 "converter-plugin-backend.c"
		}
#line 107 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		num = _tmp17_;
#line 108 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp18_ = match_info;
#line 108 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp19_ = g_match_info_fetch (_tmp18_, 2);
#line 108 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		unit1_s = _tmp19_;
#line 109 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp20_ = match_info;
#line 109 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp21_ = g_match_info_fetch (_tmp20_, 3);
#line 109 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp22_ = _tmp21_;
#line 109 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		dimension1 = CLAMP (atoi (_tmp22_), 1, 3);
#line 109 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (_tmp22_);
#line 110 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp23_ = match_info;
#line 110 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp24_ = g_match_info_fetch (_tmp23_, 4);
#line 110 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		unit2_s = _tmp24_;
#line 111 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp25_ = match_info;
#line 111 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp26_ = g_match_info_fetch (_tmp25_, 5);
#line 111 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp27_ = _tmp26_;
#line 111 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		dimension2 = CLAMP (atoi (_tmp27_), 1, 3);
#line 111 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (_tmp27_);
#line 112 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp28_ = unit1_s;
#line 112 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_converter_plugin_backend_get_prefix (self, _tmp28_, &_tmp29_, &_tmp30_);
#line 112 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (prefix1_s);
#line 112 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		prefix1_s = _tmp29_;
#line 112 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_si_prefix_destroy (&prefix1);
#line 112 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		prefix1 = _tmp30_;
#line 113 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp31_ = unit2_s;
#line 113 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_converter_plugin_backend_get_prefix (self, _tmp31_, &_tmp32_, &_tmp33_);
#line 113 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (prefix2_s);
#line 113 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		prefix2_s = _tmp32_;
#line 113 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_si_prefix_destroy (&prefix2);
#line 113 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		prefix2 = _tmp33_;
#line 114 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp34_ = unit1_s;
#line 114 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp35_ = unit2_s;
#line 114 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp36_ = prefix1_s;
#line 114 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp37_ = prefix2_s;
#line 114 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_debug ("converter-plugin-backend.vala:114: num %f, unit1_s %s, unit2_s, %s, pr" \
"efix1 %s, prefix2 %s, dimension1 %i, dimension2 %i", num, _tmp34_, _tmp35_, _tmp36_, _tmp37_, dimension1, dimension2);
#line 1042 "converter-plugin-backend.c"
		{
			SynapseUnit* u_collection = NULL;
			gint u_collection_length1 = 0;
			gint _u_collection_size_ = 0;
			gint u_it = 0;
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			u_collection = SYNAPSE_UNITS;
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			u_collection_length1 = G_N_ELEMENTS (SYNAPSE_UNITS);
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			for (u_it = 0; u_it < u_collection_length1; u_it = u_it + 1) {
#line 1054 "converter-plugin-backend.c"
				SynapseUnit _tmp38_;
				SynapseUnit _tmp39_ = {0};
				SynapseUnit u = {0};
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp38_ = u_collection[u_it];
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				synapse_unit_copy (&_tmp38_, &_tmp39_);
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				u = _tmp39_;
#line 1064 "converter-plugin-backend.c"
				{
					SynapseUnit _tmp40_;
					const gchar* _tmp41_;
					const gchar* _tmp42_;
					gboolean _tmp43_ = FALSE;
					gboolean _tmp44_;
					SynapseUnit _tmp56_;
					const gchar* _tmp57_;
					const gchar* _tmp58_;
					gboolean _tmp59_ = FALSE;
					gboolean _tmp60_;
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp40_ = u;
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp41_ = unit1_s;
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp42_ = prefix1_s;
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp44_ = synapse_converter_plugin_backend_check_match (self, &_tmp40_, _tmp41_, _tmp42_, dimension1, &_tmp43_);
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					use_prefix = _tmp43_;
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (_tmp44_) {
#line 1088 "converter-plugin-backend.c"
						SynapseSIPrefix _tmp45_ = {0};
						SynapseUnit _tmp50_;
						SynapseUnit _tmp51_;
						SynapseUnit _tmp52_ = {0};
						SynapseSIPrefix _tmp53_;
						SynapseSIPrefix _tmp54_ = {0};
						SynapseUnitMatch _tmp55_ = {0};
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						if (use_prefix) {
#line 1098 "converter-plugin-backend.c"
							SynapseSIPrefix _tmp46_;
							SynapseSIPrefix _tmp47_;
							SynapseSIPrefix _tmp48_ = {0};
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp46_ = prefix1;
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp47_ = _tmp46_;
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_copy (&_tmp47_, &_tmp48_);
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_destroy (&_tmp45_);
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp45_ = _tmp48_;
#line 1112 "converter-plugin-backend.c"
						} else {
							SynapseSIPrefix _tmp49_ = {0};
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_get_default (&_tmp49_);
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_destroy (&_tmp45_);
#line 125 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp45_ = _tmp49_;
#line 1121 "converter-plugin-backend.c"
						}
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp50_ = u;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp51_ = _tmp50_;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_unit_copy (&_tmp51_, &_tmp52_);
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp53_ = _tmp45_;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_copy (&_tmp53_, &_tmp54_);
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						memset (&_tmp55_, 0, sizeof (SynapseUnitMatch));
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_unit_destroy (&_tmp55_.unit);
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp55_.unit = _tmp52_;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_destroy (&_tmp55_.prefix);
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp55_.prefix = _tmp54_;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp55_.dimension = dimension1;
#line 123 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_vala_array_add11 (&match_arr1, &match_arr1_length1, &_match_arr1_size_, &_tmp55_);
#line 122 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_destroy (&_tmp45_);
#line 1149 "converter-plugin-backend.c"
					}
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp56_ = u;
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp57_ = unit2_s;
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp58_ = prefix2_s;
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp60_ = synapse_converter_plugin_backend_check_match (self, &_tmp56_, _tmp57_, _tmp58_, dimension2, &_tmp59_);
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					use_prefix = _tmp59_;
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (_tmp60_) {
#line 1163 "converter-plugin-backend.c"
						SynapseSIPrefix _tmp61_ = {0};
						SynapseUnit _tmp66_;
						SynapseUnit _tmp67_;
						SynapseUnit _tmp68_ = {0};
						SynapseSIPrefix _tmp69_;
						SynapseSIPrefix _tmp70_ = {0};
						SynapseUnitMatch _tmp71_ = {0};
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						if (use_prefix) {
#line 1173 "converter-plugin-backend.c"
							SynapseSIPrefix _tmp62_;
							SynapseSIPrefix _tmp63_;
							SynapseSIPrefix _tmp64_ = {0};
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp62_ = prefix2;
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp63_ = _tmp62_;
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_copy (&_tmp63_, &_tmp64_);
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_destroy (&_tmp61_);
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp61_ = _tmp64_;
#line 1187 "converter-plugin-backend.c"
						} else {
							SynapseSIPrefix _tmp65_ = {0};
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_get_default (&_tmp65_);
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_si_prefix_destroy (&_tmp61_);
#line 133 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp61_ = _tmp65_;
#line 1196 "converter-plugin-backend.c"
						}
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp66_ = u;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp67_ = _tmp66_;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_unit_copy (&_tmp67_, &_tmp68_);
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp69_ = _tmp61_;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_copy (&_tmp69_, &_tmp70_);
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						memset (&_tmp71_, 0, sizeof (SynapseUnitMatch));
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_unit_destroy (&_tmp71_.unit);
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp71_.unit = _tmp68_;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_destroy (&_tmp71_.prefix);
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp71_.prefix = _tmp70_;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp71_.dimension = dimension2;
#line 131 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_vala_array_add12 (&match_arr2, &match_arr2_length1, &_match_arr2_size_, &_tmp71_);
#line 130 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_destroy (&_tmp61_);
#line 1224 "converter-plugin-backend.c"
					}
#line 121 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					synapse_unit_destroy (&u);
#line 1228 "converter-plugin-backend.c"
				}
			}
		}
#line 104 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (unit2_s);
#line 104 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (unit1_s);
#line 1236 "converter-plugin-backend.c"
	}
#line 140 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp72_ = match_arr1;
#line 140 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp72__length1 = match_arr1_length1;
#line 140 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp73_ = match_arr2;
#line 140 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp73__length1 = match_arr2_length1;
#line 140 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_debug ("converter-plugin-backend.vala:140: Expect %u results", (guint) (_tmp72__length1 * _tmp73__length1));
#line 141 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (num != 0.0) {
#line 1250 "converter-plugin-backend.c"
		SynapseUnitMatch* _tmp74_;
		gint _tmp74__length1;
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp74_ = match_arr1;
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp74__length1 = match_arr1_length1;
#line 1257 "converter-plugin-backend.c"
		{
			SynapseUnitMatch* match1_collection = NULL;
			gint match1_collection_length1 = 0;
			gint _match1_collection_size_ = 0;
			gint match1_it = 0;
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			match1_collection = _tmp74_;
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			match1_collection_length1 = _tmp74__length1;
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			for (match1_it = 0; match1_it < match1_collection_length1; match1_it = match1_it + 1) {
#line 1269 "converter-plugin-backend.c"
				SynapseUnitMatch _tmp75_;
				SynapseUnitMatch _tmp76_ = {0};
				SynapseUnitMatch match1 = {0};
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp75_ = match1_collection[match1_it];
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				synapse_unit_match_copy (&_tmp75_, &_tmp76_);
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				match1 = _tmp76_;
#line 1279 "converter-plugin-backend.c"
				{
					SynapseUnitMatch* _tmp77_;
					gint _tmp77__length1;
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp77_ = match_arr2;
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp77__length1 = match_arr2_length1;
#line 1287 "converter-plugin-backend.c"
					{
						SynapseUnitMatch* match2_collection = NULL;
						gint match2_collection_length1 = 0;
						gint _match2_collection_size_ = 0;
						gint match2_it = 0;
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						match2_collection = _tmp77_;
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						match2_collection_length1 = _tmp77__length1;
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						for (match2_it = 0; match2_it < match2_collection_length1; match2_it = match2_it + 1) {
#line 1299 "converter-plugin-backend.c"
							SynapseUnitMatch _tmp78_;
							SynapseUnitMatch _tmp79_ = {0};
							SynapseUnitMatch match2 = {0};
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							_tmp78_ = match2_collection[match2_it];
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							synapse_unit_match_copy (&_tmp78_, &_tmp79_);
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							match2 = _tmp79_;
#line 1309 "converter-plugin-backend.c"
							{
								SynapseUnitMatch _tmp80_;
								SynapseUnit _tmp81_;
								SynapseUnitMatch _tmp82_;
								SynapseUnit _tmp83_;
#line 146 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
								_tmp80_ = match1;
#line 146 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
								_tmp81_ = _tmp80_.unit;
#line 146 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
								_tmp82_ = match2;
#line 146 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
								_tmp83_ = _tmp82_.unit;
#line 146 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
								if (_tmp81_.type == _tmp83_.type) {
#line 1325 "converter-plugin-backend.c"
									gboolean _tmp84_ = FALSE;
									SynapseUnitMatch _tmp85_;
									SynapseUnit _tmp86_;
#line 147 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
									_tmp85_ = match1;
#line 147 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
									_tmp86_ = _tmp85_.unit;
#line 147 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
									if (_tmp86_.type == SYNAPSE_UNIT_TYPE_DIMENSION) {
#line 147 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp84_ = TRUE;
#line 1337 "converter-plugin-backend.c"
									} else {
										gboolean _tmp87_ = FALSE;
										SynapseUnitMatch _tmp88_;
#line 148 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp88_ = match1;
#line 148 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										if (_tmp88_.dimension == 1) {
#line 1345 "converter-plugin-backend.c"
											SynapseUnitMatch _tmp89_;
#line 148 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											_tmp89_ = match2;
#line 148 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											_tmp87_ = _tmp89_.dimension == 1;
#line 1351 "converter-plugin-backend.c"
										} else {
#line 148 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											_tmp87_ = FALSE;
#line 1355 "converter-plugin-backend.c"
										}
#line 148 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp84_ = _tmp87_;
#line 1359 "converter-plugin-backend.c"
									}
#line 147 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
									if (_tmp84_) {
#line 1363 "converter-plugin-backend.c"
										SynapseResultData* _result_ = NULL;
										SynapseUnitMatch _tmp90_;
										SynapseUnitMatch _tmp91_;
										SynapseResultData* _tmp92_;
										SynapseResultData* _tmp93_;
#line 150 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp90_ = match1;
#line 150 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp91_ = match2;
#line 150 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp92_ = synapse_converter_plugin_backend_calculate_conversion_data (self, num, &_tmp90_, &_tmp91_);
#line 150 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_result_ = _tmp92_;
#line 151 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_tmp93_ = _result_;
#line 151 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										if (_tmp93_ != NULL) {
#line 1381 "converter-plugin-backend.c"
											SynapseResultData* _tmp94_;
											SynapseResultData _tmp95_;
											SynapseResultData _tmp96_ = {0};
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											_tmp94_ = _result_;
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											_tmp95_ = *_tmp94_;
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											synapse_result_data_copy (&_tmp95_, &_tmp96_);
#line 152 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
											_vala_array_add13 (&results, &results_length1, &_results_size_, &_tmp96_);
#line 1393 "converter-plugin-backend.c"
										}
#line 147 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
										_synapse_result_data_free0 (_result_);
#line 1397 "converter-plugin-backend.c"
									}
								}
#line 144 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
								synapse_unit_match_destroy (&match2);
#line 1402 "converter-plugin-backend.c"
							}
						}
					}
#line 143 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					synapse_unit_match_destroy (&match1);
#line 1408 "converter-plugin-backend.c"
				}
			}
		}
	}
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp97_ = results;
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp97__length1 = results_length1;
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (result_length1) {
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*result_length1 = _tmp97__length1;
#line 1421 "converter-plugin-backend.c"
	}
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	result = _tmp97_;
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (prefix2_s);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (prefix1_s);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_destroy (&prefix2);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_destroy (&prefix1);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_arr2 = (_vala_SynapseUnitMatch_array_free (match_arr2, match_arr2_length1), NULL);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_arr1 = (_vala_SynapseUnitMatch_array_free (match_arr1, match_arr1_length1), NULL);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_match_info_unref0 (match_info);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (input);
#line 160 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return result;
#line 1443 "converter-plugin-backend.c"
}

static gpointer
_synapse_unit_dup0 (gpointer self)
{
#line 177 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return self ? synapse_unit_dup (self) : NULL;
#line 1451 "converter-plugin-backend.c"
}

static gpointer
_synapse_result_data_dup0 (gpointer self)
{
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return self ? synapse_result_data_dup (self) : NULL;
#line 1459 "converter-plugin-backend.c"
}

static SynapseResultData*
synapse_converter_plugin_backend_calculate_conversion_data (SynapseConverterPluginBackend* self,
                                                            gdouble num,
                                                            SynapseUnitMatch* match1,
                                                            SynapseUnitMatch* match2)
{
	SynapseUnit u1 = {0};
	SynapseUnitMatch _tmp0_;
	SynapseUnit _tmp1_;
	SynapseUnit _tmp2_;
	SynapseUnit _tmp3_ = {0};
	SynapseUnit u2 = {0};
	SynapseUnitMatch _tmp4_;
	SynapseUnit _tmp5_;
	SynapseUnit _tmp6_;
	SynapseUnit _tmp7_ = {0};
	gint dim1 = 0;
	SynapseUnitMatch _tmp8_;
	gint dim2 = 0;
	SynapseUnitMatch _tmp9_;
	gdouble factor1 = 0.0;
	gdouble factor2 = 0.0;
	gchar* descr1 = NULL;
	gchar* _tmp10_;
	gchar* descr2 = NULL;
	gchar* _tmp11_;
	gboolean same_system = FALSE;
	SynapseUnit _tmp12_;
	SynapseUnit _tmp13_;
	SynapseUnit* parent = NULL;
	SynapseUnit _tmp14_;
	SynapseUnit _tmp15_;
	SynapseUnit* _tmp16_;
	SynapseUnit _tmp17_;
	const gchar* _tmp18_;
	SynapseUnit _tmp19_;
	SynapseUnit* _tmp20_;
	gchar* ultimate_parent1 = NULL;
	SynapseUnit* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	SynapseUnit _tmp24_;
	SynapseUnit _tmp25_;
	SynapseUnit* _tmp26_;
	SynapseUnit _tmp27_;
	const gchar* _tmp28_;
	SynapseUnit _tmp29_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	SynapseUnit* _tmp34_;
	SynapseResultData* result;
#line 163 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (match1 != NULL, NULL);
#line 163 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (match2 != NULL, NULL);
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = *match1;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp1_ = _tmp0_.unit;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp2_ = _tmp1_;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_copy (&_tmp2_, &_tmp3_);
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	u1 = _tmp3_;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp4_ = *match2;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp5_ = _tmp4_.unit;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp6_ = _tmp5_;
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_copy (&_tmp6_, &_tmp7_);
#line 168 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	u2 = _tmp7_;
#line 169 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp8_ = *match1;
#line 169 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dim1 = _tmp8_.dimension;
#line 169 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp9_ = *match2;
#line 169 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	dim2 = _tmp9_.dimension;
#line 170 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	factor1 = synapse_unit_match_factor (match1);
#line 170 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	factor2 = synapse_unit_match_factor (match2);
#line 171 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp10_ = synapse_unit_match_description (match1);
#line 171 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	descr1 = _tmp10_;
#line 171 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp11_ = synapse_unit_match_description (match2);
#line 171 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	descr2 = _tmp11_;
#line 172 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp12_ = u1;
#line 172 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp13_ = u2;
#line 172 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	same_system = _tmp12_.system == _tmp13_.system;
#line 177 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp14_ = u1;
#line 177 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp15_ = _tmp14_;
#line 177 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp16_ = _synapse_unit_dup0 (&_tmp15_);
#line 177 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	parent = _tmp16_;
#line 179 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp17_ = u1;
#line 179 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp18_ = _tmp17_.uid;
#line 179 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_debug ("converter-plugin-backend.vala:179: finding root of %s - start dimensio" \
"n %i, start factor %f", _tmp18_, dim1, factor1);
#line 180 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp19_ = u1;
#line 180 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_converter_plugin_backend_find_root (self, &parent, &dim1, &factor1, same_system, _tmp19_.system);
#line 181 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp20_ = parent;
#line 181 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp20_ == NULL) {
#line 182 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_debug ("converter-plugin-backend.vala:182: parent1 is null");
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		result = NULL;
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_synapse_unit_free0 (parent);
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (descr2);
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (descr1);
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_unit_destroy (&u2);
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_unit_destroy (&u1);
#line 183 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		return result;
#line 1605 "converter-plugin-backend.c"
	}
#line 186 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp21_ = parent;
#line 186 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp22_ = (*_tmp21_).uid;
#line 186 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 186 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	ultimate_parent1 = _tmp23_;
#line 187 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp24_ = u2;
#line 187 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp25_ = _tmp24_;
#line 187 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp26_ = _synapse_unit_dup0 (&_tmp25_);
#line 187 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_synapse_unit_free0 (parent);
#line 187 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	parent = _tmp26_;
#line 188 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp27_ = u2;
#line 188 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp28_ = _tmp27_.uid;
#line 188 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_debug ("converter-plugin-backend.vala:188: finding root of %s - start dimensio" \
"n %i, start factor2 %f", _tmp28_, dim2, factor2);
#line 189 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp29_ = u2;
#line 189 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_converter_plugin_backend_find_root (self, &parent, &dim2, &factor2, same_system, _tmp29_.system);
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp34_ = parent;
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp34_ != NULL) {
#line 1639 "converter-plugin-backend.c"
		const gchar* _tmp35_;
		SynapseUnit* _tmp36_;
		const gchar* _tmp37_;
#line 192 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp35_ = ultimate_parent1;
#line 192 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp36_ = parent;
#line 192 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp37_ = (*_tmp36_).uid;
#line 192 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp33_ = g_strcmp0 (_tmp35_, _tmp37_) == 0;
#line 1651 "converter-plugin-backend.c"
	} else {
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp33_ = FALSE;
#line 1655 "converter-plugin-backend.c"
	}
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp33_) {
#line 193 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp32_ = factor1 > ((gdouble) 0);
#line 1661 "converter-plugin-backend.c"
	} else {
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp32_ = FALSE;
#line 1665 "converter-plugin-backend.c"
	}
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp32_) {
#line 193 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp31_ = factor2 > ((gdouble) 0);
#line 1671 "converter-plugin-backend.c"
	} else {
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp31_ = FALSE;
#line 1675 "converter-plugin-backend.c"
	}
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp31_) {
#line 194 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp30_ = dim1 == dim2;
#line 1681 "converter-plugin-backend.c"
	} else {
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp30_ = FALSE;
#line 1685 "converter-plugin-backend.c"
	}
#line 191 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (_tmp30_) {
#line 1689 "converter-plugin-backend.c"
		gdouble d = 0.0;
		const gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		SynapseResultData _tmp42_ = {0};
		SynapseResultData _tmp43_;
		SynapseResultData* _tmp44_;
		SynapseResultData* _tmp45_;
#line 195 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		d = (num * factor1) / factor2;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp38_ = descr1;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp39_ = g_strdup (_tmp38_);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp40_ = descr2;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		memset (&_tmp42_, 0, sizeof (SynapseResultData));
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp42_.factor = d;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (_tmp42_.from_description);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp42_.from_description = _tmp39_;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (_tmp42_.to_description);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp42_.to_description = _tmp41_;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp43_ = _tmp42_;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp44_ = _synapse_result_data_dup0 (&_tmp43_);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp45_ = _tmp44_;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_result_data_destroy (&_tmp43_);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		result = _tmp45_;
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (ultimate_parent1);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_synapse_unit_free0 (parent);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (descr2);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (descr1);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_unit_destroy (&u2);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_unit_destroy (&u1);
#line 197 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		return result;
#line 1745 "converter-plugin-backend.c"
	}
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	result = NULL;
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (ultimate_parent1);
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_synapse_unit_free0 (parent);
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (descr2);
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (descr1);
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_destroy (&u2);
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_unit_destroy (&u1);
#line 204 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return result;
#line 1763 "converter-plugin-backend.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 1780 "converter-plugin-backend.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 1807 "converter-plugin-backend.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 1813 "converter-plugin-backend.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1819 "converter-plugin-backend.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1823 "converter-plugin-backend.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1831 "converter-plugin-backend.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1835 "converter-plugin-backend.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 1847 "converter-plugin-backend.c"
}

static void
synapse_converter_plugin_backend_find_root (SynapseConverterPluginBackend* self,
                                            SynapseUnit** parent,
                                            gint* dim,
                                            gdouble* factor,
                                            gboolean same_system,
                                            SynapseUnitSystem match_unit_system)
{
#line 207 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	while (TRUE) {
#line 1862 "converter-plugin-backend.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		gint link_dimension = 0;
		gchar* base_uid = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gint length = 0;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gdouble pfactor = 0.0;
		const gchar* _tmp22_;
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if ((*parent) != NULL) {
#line 1877 "converter-plugin-backend.c"
			const gchar* _tmp2_;
#line 209 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp2_ = (*(*parent)).base_unit;
#line 209 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp1_ = g_strcmp0 (_tmp2_, "") != 0;
#line 1883 "converter-plugin-backend.c"
		} else {
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp1_ = FALSE;
#line 1887 "converter-plugin-backend.c"
		}
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if (_tmp1_) {
#line 1891 "converter-plugin-backend.c"
			gboolean _tmp3_ = FALSE;
#line 210 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			if (!same_system) {
#line 210 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp3_ = TRUE;
#line 1897 "converter-plugin-backend.c"
			} else {
#line 210 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp3_ = (*(*parent)).system == match_unit_system;
#line 1901 "converter-plugin-backend.c"
			}
#line 210 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp0_ = _tmp3_;
#line 1905 "converter-plugin-backend.c"
		} else {
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp0_ = FALSE;
#line 1909 "converter-plugin-backend.c"
		}
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if (!_tmp0_) {
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			break;
#line 1915 "converter-plugin-backend.c"
		}
#line 212 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		link_dimension = 1;
#line 213 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp4_ = (*(*parent)).base_unit;
#line 213 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 213 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		base_uid = _tmp5_;
#line 214 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp6_ = base_uid;
#line 214 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp7_ = strlen (_tmp6_);
#line 214 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp8_ = _tmp7_;
#line 214 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		length = _tmp8_;
#line 215 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if (length > 1) {
#line 1935 "converter-plugin-backend.c"
			gchar last_c = '\0';
			const gchar* _tmp9_;
#line 216 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp9_ = base_uid;
#line 216 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			last_c = string_get (_tmp9_, (glong) (length - 1));
#line 217 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			if (g_ascii_isdigit (last_c)) {
#line 1944 "converter-plugin-backend.c"
				const gchar* _tmp10_;
				gchar* _tmp11_;
				const gchar* _tmp12_;
#line 218 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				link_dimension = g_ascii_digit_value (last_c);
#line 219 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp10_ = base_uid;
#line 219 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp11_ = string_slice (_tmp10_, (glong) 0, (glong) -1);
#line 219 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_g_free0 (base_uid);
#line 219 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				base_uid = _tmp11_;
#line 220 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp12_ = base_uid;
#line 220 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				g_debug ("converter-plugin-backend.vala:220: Link dimension %i, base_uid %s", link_dimension, _tmp12_);
#line 1962 "converter-plugin-backend.c"
			}
		}
#line 224 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_synapse_unit_free0 (*parent);
#line 224 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*parent = NULL;
#line 1969 "converter-plugin-backend.c"
		{
			SynapseUnit* u_collection = NULL;
			gint u_collection_length1 = 0;
			gint _u_collection_size_ = 0;
			gint u_it = 0;
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			u_collection = SYNAPSE_UNITS;
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			u_collection_length1 = G_N_ELEMENTS (SYNAPSE_UNITS);
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			for (u_it = 0; u_it < u_collection_length1; u_it = u_it + 1) {
#line 1981 "converter-plugin-backend.c"
				SynapseUnit _tmp13_;
				SynapseUnit _tmp14_ = {0};
				SynapseUnit u = {0};
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp13_ = u_collection[u_it];
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				synapse_unit_copy (&_tmp13_, &_tmp14_);
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				u = _tmp14_;
#line 1991 "converter-plugin-backend.c"
				{
					SynapseUnit _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
#line 226 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp15_ = u;
#line 226 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp16_ = _tmp15_.uid;
#line 226 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp17_ = base_uid;
#line 226 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 2004 "converter-plugin-backend.c"
						SynapseUnit _tmp18_;
						SynapseUnit _tmp19_;
						SynapseUnit* _tmp20_;
#line 227 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp18_ = u;
#line 227 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp19_ = _tmp18_;
#line 227 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp20_ = _synapse_unit_dup0 (&_tmp19_);
#line 227 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_synapse_unit_free0 (*parent);
#line 227 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						*parent = _tmp20_;
#line 228 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_unit_destroy (&u);
#line 228 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						break;
#line 2022 "converter-plugin-backend.c"
					}
#line 225 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					synapse_unit_destroy (&u);
#line 2026 "converter-plugin-backend.c"
				}
			}
		}
#line 232 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if ((*parent) == NULL) {
#line 2032 "converter-plugin-backend.c"
			const gchar* _tmp21_;
#line 233 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp21_ = base_uid;
#line 233 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			g_critical ("converter-plugin-backend.vala:233: Unable to find parent for %s - data" \
" error", _tmp21_);
#line 234 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_g_free0 (base_uid);
#line 234 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			return;
#line 2042 "converter-plugin-backend.c"
		}
#line 237 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		pfactor = synapse_unit_get_factor (*parent);
#line 238 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp22_ = (*(*parent)).uid;
#line 238 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_debug ("converter-plugin-backend.vala:238: Found parent %s parent_dimension %i" \
", parent_factor %f", _tmp22_, link_dimension, pfactor);
#line 242 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*dim = (*dim) * link_dimension;
#line 243 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_debug ("converter-plugin-backend.vala:243: Dim now %i", *dim);
#line 2054 "converter-plugin-backend.c"
		{
			gint i = 0;
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			i = 0;
#line 2059 "converter-plugin-backend.c"
			{
				gboolean _tmp23_ = FALSE;
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp23_ = TRUE;
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				while (TRUE) {
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (!_tmp23_) {
#line 2068 "converter-plugin-backend.c"
						gint _tmp24_;
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp24_ = i;
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						i = _tmp24_ + 1;
#line 2074 "converter-plugin-backend.c"
					}
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp23_ = FALSE;
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (!(i < (*dim))) {
#line 244 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						break;
#line 2082 "converter-plugin-backend.c"
					}
#line 245 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					*factor = (*factor) * pfactor;
#line 2086 "converter-plugin-backend.c"
				}
			}
		}
#line 208 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (base_uid);
#line 2092 "converter-plugin-backend.c"
	}
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if ((*length) == (*size)) {
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2108 "converter-plugin-backend.c"
	}
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[(*length)++] = value;
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[*length] = NULL;
#line 2114 "converter-plugin-backend.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if ((*length) == (*size)) {
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2129 "converter-plugin-backend.c"
	}
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[(*length)++] = value;
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	(*array)[*length] = NULL;
#line 2135 "converter-plugin-backend.c"
}

static gboolean
synapse_converter_plugin_backend_check_match (SynapseConverterPluginBackend* self,
                                              SynapseUnit* u,
                                              const gchar* unit_s,
                                              const gchar* prefix,
                                              gint dimension,
                                              gboolean* use_prefix)
{
	gboolean _vala_use_prefix = FALSE;
	gchar** ids = NULL;
	SynapseUnit _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint ids_length1;
	gint _ids_size_;
	gchar** abbreviations = NULL;
	SynapseUnit _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint abbreviations_length1;
	gint _abbreviations_size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	SynapseUnit _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* match = NULL;
	gchar* _tmp15_;
	gchar* match_no_prefix = NULL;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	const gchar* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gboolean result;
#line 250 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (u != NULL, FALSE);
#line 250 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (unit_s != NULL, FALSE);
#line 250 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_val_if_fail (prefix != NULL, FALSE);
#line 257 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_vala_use_prefix = FALSE;
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp0_ = *u;
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp1_ = _tmp0_.uid;
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_[0] = _tmp2_;
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	ids = _tmp3_;
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	ids_length1 = 1;
#line 258 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_ids_size_ = ids_length1;
#line 259 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp4_ = *u;
#line 259 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp5_ = _tmp4_.abbreviations;
#line 259 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "|", 0);
#line 259 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	abbreviations = _tmp7_;
#line 259 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	abbreviations_length1 = _vala_array_length (_tmp6_);
#line 259 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_abbreviations_size_ = abbreviations_length1;
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp8_ = abbreviations;
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp8__length1 = abbreviations_length1;
#line 2223 "converter-plugin-backend.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		s_collection = _tmp8_;
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		s_collection_length1 = _tmp8__length1;
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 2235 "converter-plugin-backend.c"
			gchar* _tmp9_;
			gchar* s = NULL;
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp9_ = g_strdup (s_collection[s_it]);
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			s = _tmp9_;
#line 2242 "converter-plugin-backend.c"
			{
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp10_ = s;
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp11_ = g_strdup (_tmp10_);
#line 261 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_vala_array_add14 (&ids, &ids_length1, &_ids_size_, _tmp11_);
#line 260 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_g_free0 (s);
#line 2254 "converter-plugin-backend.c"
			}
		}
	}
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp12_ = *u;
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp13_ = _tmp12_.description;
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp14_ = g_utf8_strdown (_ (_tmp13_), (gssize) -1);
#line 264 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_vala_array_add15 (&ids, &ids_length1, &_ids_size_, _tmp14_);
#line 266 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp15_ = g_utf8_strdown (unit_s, (gssize) -1);
#line 266 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match = _tmp15_;
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp16_ = match;
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp17_ = strlen (prefix);
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp18_ = _tmp17_;
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp19_ = match;
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp20_ = strlen (_tmp19_);
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp21_ = _tmp20_;
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp22_ = string_slice (_tmp16_, (glong) _tmp18_, (glong) _tmp21_);
#line 267 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	match_no_prefix = _tmp22_;
#line 268 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp23_ = match;
#line 268 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp24_ = match_no_prefix;
#line 268 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_debug ("converter-plugin-backend.vala:268: match %s, match no prefix %s", _tmp23_, _tmp24_);
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp25_ = ids;
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp25__length1 = ids_length1;
#line 2296 "converter-plugin-backend.c"
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		id_collection = _tmp25_;
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		id_collection_length1 = _tmp25__length1;
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 2308 "converter-plugin-backend.c"
			gchar* _tmp26_;
			gchar* id = NULL;
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp26_ = g_strdup (id_collection[id_it]);
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			id = _tmp26_;
#line 2315 "converter-plugin-backend.c"
			{
				const gchar* _tmp27_;
				const gchar* _tmp28_;
#line 270 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp27_ = match;
#line 270 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp28_ = id;
#line 270 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
#line 2325 "converter-plugin-backend.c"
					const gchar* _tmp29_;
#line 271 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp29_ = id;
#line 271 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					g_debug ("converter-plugin-backend.vala:271: unit less dimension (if any) matche" \
"s %s", _tmp29_);
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					result = TRUE;
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_g_free0 (id);
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_g_free0 (match_no_prefix);
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_g_free0 (match);
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					abbreviations = (_vala_array_free (abbreviations, abbreviations_length1, (GDestroyNotify) g_free), NULL);
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (use_prefix) {
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						*use_prefix = _vala_use_prefix;
#line 2347 "converter-plugin-backend.c"
					}
#line 272 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					return result;
#line 2351 "converter-plugin-backend.c"
				} else {
					const gchar* _tmp30_;
					const gchar* _tmp31_;
#line 273 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp30_ = match_no_prefix;
#line 273 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp31_ = id;
#line 273 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (g_strcmp0 (_tmp30_, _tmp31_) == 0) {
#line 2361 "converter-plugin-backend.c"
						const gchar* _tmp32_;
#line 274 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp32_ = id;
#line 274 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						g_debug ("converter-plugin-backend.vala:274: unit less dimension (if any) and le" \
"ss prefix matches %s", _tmp32_);
#line 275 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_vala_use_prefix = TRUE;
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						result = TRUE;
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_g_free0 (id);
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_g_free0 (match_no_prefix);
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_g_free0 (match);
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						abbreviations = (_vala_array_free (abbreviations, abbreviations_length1, (GDestroyNotify) g_free), NULL);
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						if (use_prefix) {
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
							*use_prefix = _vala_use_prefix;
#line 2385 "converter-plugin-backend.c"
						}
#line 276 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						return result;
#line 2389 "converter-plugin-backend.c"
					}
				}
#line 269 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_g_free0 (id);
#line 2394 "converter-plugin-backend.c"
			}
		}
	}
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	result = FALSE;
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (match_no_prefix);
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (match);
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	abbreviations = (_vala_array_free (abbreviations, abbreviations_length1, (GDestroyNotify) g_free), NULL);
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (use_prefix) {
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*use_prefix = _vala_use_prefix;
#line 2412 "converter-plugin-backend.c"
	}
#line 280 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return result;
#line 2416 "converter-plugin-backend.c"
}

static void
synapse_converter_plugin_backend_get_prefix (SynapseConverterPluginBackend* self,
                                             const gchar* unit_s,
                                             gchar** prefix_s,
                                             SynapseSIPrefix* prefix)
{
	gchar* _vala_prefix_s = NULL;
	SynapseSIPrefix _vala_prefix = {0};
	SynapseSIPrefix _tmp0_ = {0};
	gchar* _tmp1_;
	gint length = 0;
	gint _tmp2_;
	gint _tmp3_;
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_return_if_fail (unit_s != NULL);
#line 288 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_get_default (&_tmp0_);
#line 288 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_si_prefix_destroy (&_vala_prefix);
#line 288 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_vala_prefix = _tmp0_;
#line 289 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp1_ = g_strdup ("");
#line 289 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_free0 (_vala_prefix_s);
#line 289 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_vala_prefix_s = _tmp1_;
#line 290 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp2_ = strlen (unit_s);
#line 290 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_tmp3_ = _tmp2_;
#line 290 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	length = _tmp3_;
#line 2454 "converter-plugin-backend.c"
	{
		SynapseSIPrefix* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		p_collection = SYNAPSE_PREFIXES;
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		p_collection_length1 = G_N_ELEMENTS (SYNAPSE_PREFIXES);
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 2466 "converter-plugin-backend.c"
			SynapseSIPrefix _tmp4_;
			SynapseSIPrefix _tmp5_ = {0};
			SynapseSIPrefix p = {0};
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			_tmp4_ = p_collection[p_it];
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			synapse_si_prefix_copy (&_tmp4_, &_tmp5_);
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
			p = _tmp5_;
#line 2476 "converter-plugin-backend.c"
			{
				gboolean _tmp6_ = FALSE;
				SynapseSIPrefix _tmp7_;
				const gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp7_ = p;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp8_ = _tmp7_.prefix;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp9_ = strlen (_tmp8_);
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				_tmp10_ = _tmp9_;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				if (length > _tmp10_) {
#line 2493 "converter-plugin-backend.c"
					SynapseSIPrefix _tmp11_;
					const gchar* _tmp12_;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp11_ = p;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp12_ = _tmp11_.prefix;
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp6_ = g_str_has_prefix (unit_s, _tmp12_);
#line 2502 "converter-plugin-backend.c"
				} else {
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp6_ = FALSE;
#line 2506 "converter-plugin-backend.c"
				}
#line 293 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				if (_tmp6_) {
#line 2510 "converter-plugin-backend.c"
					SynapseSIPrefix _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					SynapseSIPrefix _tmp16_;
					SynapseSIPrefix _tmp17_;
					SynapseSIPrefix _tmp18_ = {0};
#line 294 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp13_ = p;
#line 294 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp14_ = _tmp13_.prefix;
#line 294 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 294 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_g_free0 (_vala_prefix_s);
#line 294 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_vala_prefix_s = _tmp15_;
#line 295 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp16_ = p;
#line 295 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp17_ = _tmp16_;
#line 295 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					synapse_si_prefix_copy (&_tmp17_, &_tmp18_);
#line 295 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					synapse_si_prefix_destroy (&_vala_prefix);
#line 295 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_vala_prefix = _tmp18_;
#line 296 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					synapse_si_prefix_destroy (&p);
#line 296 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					break;
#line 2541 "converter-plugin-backend.c"
				} else {
					gboolean _tmp19_ = FALSE;
					SynapseSIPrefix _tmp20_;
					const gchar* _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp20_ = p;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp21_ = _tmp20_.abbrev;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp22_ = strlen (_tmp21_);
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					_tmp23_ = _tmp22_;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (length > _tmp23_) {
#line 2558 "converter-plugin-backend.c"
						SynapseSIPrefix _tmp24_;
						const gchar* _tmp25_;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp24_ = p;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp25_ = _tmp24_.abbrev;
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp19_ = g_str_has_prefix (unit_s, _tmp25_);
#line 2567 "converter-plugin-backend.c"
					} else {
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp19_ = FALSE;
#line 2571 "converter-plugin-backend.c"
					}
#line 297 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
					if (_tmp19_) {
#line 2575 "converter-plugin-backend.c"
						SynapseSIPrefix _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						SynapseSIPrefix _tmp29_;
						SynapseSIPrefix _tmp30_;
						SynapseSIPrefix _tmp31_ = {0};
#line 298 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp26_ = p;
#line 298 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp27_ = _tmp26_.abbrev;
#line 298 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp28_ = g_strdup (_tmp27_);
#line 298 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_g_free0 (_vala_prefix_s);
#line 298 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_vala_prefix_s = _tmp28_;
#line 299 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp29_ = p;
#line 299 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_tmp30_ = _tmp29_;
#line 299 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_copy (&_tmp30_, &_tmp31_);
#line 299 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_destroy (&_vala_prefix);
#line 299 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						_vala_prefix = _tmp31_;
#line 300 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						synapse_si_prefix_destroy (&p);
#line 300 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
						break;
#line 2606 "converter-plugin-backend.c"
					}
				}
#line 292 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
				synapse_si_prefix_destroy (&p);
#line 2611 "converter-plugin-backend.c"
			}
		}
	}
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (prefix_s) {
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*prefix_s = _vala_prefix_s;
#line 2619 "converter-plugin-backend.c"
	} else {
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_free0 (_vala_prefix_s);
#line 2623 "converter-plugin-backend.c"
	}
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (prefix) {
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		*prefix = _vala_prefix;
#line 2629 "converter-plugin-backend.c"
	} else {
#line 283 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		synapse_si_prefix_destroy (&_vala_prefix);
#line 2633 "converter-plugin-backend.c"
	}
}

SynapseConverterPluginBackend*
synapse_converter_plugin_backend_construct (GType object_type)
{
	SynapseConverterPluginBackend * self = NULL;
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	self = (SynapseConverterPluginBackend*) g_object_new (object_type, NULL);
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return self;
#line 2645 "converter-plugin-backend.c"
}

SynapseConverterPluginBackend*
synapse_converter_plugin_backend_new (void)
{
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return synapse_converter_plugin_backend_construct (SYNAPSE_TYPE_CONVERTER_PLUGIN_BACKEND);
#line 2653 "converter-plugin-backend.c"
}

static GObject *
synapse_converter_plugin_backend_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SynapseConverterPluginBackend * self;
	GError* _inner_error0_ = NULL;
#line 71 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	parent_class = G_OBJECT_CLASS (synapse_converter_plugin_backend_parent_class);
#line 71 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_CONVERTER_PLUGIN_BACKEND, SynapseConverterPluginBackend);
#line 2671 "converter-plugin-backend.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp1_ = g_regex_new ("^([[:digit:]]*\\.?[[:digit:]]*)\\s*([[:alpha:]\\/ ]+?)([23]?)\\s*[=\\-" \
"]>\\s*([[:alpha:]\\/ ]+?)([23]?)$", G_REGEX_OPTIMIZE, 0, &_inner_error0_);
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp0_ = _tmp1_;
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2682 "converter-plugin-backend.c"
			goto __catch0_g_error;
		}
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp2_ = _tmp0_;
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp0_ = NULL;
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_regex_unref0 (self->priv->convert_regex);
#line 78 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		self->priv->convert_regex = _tmp2_;
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_regex_unref0 (_tmp0_);
#line 2695 "converter-plugin-backend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		e = _inner_error0_;
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_inner_error0_ = NULL;
#line 84 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp3_ = e;
#line 84 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_tmp4_ = _tmp3_->message;
#line 84 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_critical ("converter-plugin-backend.vala:84: Error creating regexp: %s", _tmp4_);
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		_g_error_free0 (e);
#line 2715 "converter-plugin-backend.c"
	}
	__finally0:
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
		g_clear_error (&_inner_error0_);
#line 2724 "converter-plugin-backend.c"
	}
#line 71 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	return obj;
#line 2728 "converter-plugin-backend.c"
}

static void
synapse_converter_plugin_backend_class_init (SynapseConverterPluginBackendClass * klass,
                                             gpointer klass_data)
{
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	synapse_converter_plugin_backend_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	g_type_class_adjust_private_offset (klass, &SynapseConverterPluginBackend_private_offset);
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	G_OBJECT_CLASS (klass)->constructor = synapse_converter_plugin_backend_constructor;
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_converter_plugin_backend_finalize;
#line 2743 "converter-plugin-backend.c"
}

static void
synapse_converter_plugin_backend_instance_init (SynapseConverterPluginBackend * self,
                                                gpointer klass)
{
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	self->priv = synapse_converter_plugin_backend_get_instance_private (self);
#line 68 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	self->priv->convert_regex = NULL;
#line 2754 "converter-plugin-backend.c"
}

static void
synapse_converter_plugin_backend_finalize (GObject * obj)
{
	SynapseConverterPluginBackend * self;
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_CONVERTER_PLUGIN_BACKEND, SynapseConverterPluginBackend);
#line 68 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	_g_regex_unref0 (self->priv->convert_regex);
#line 59 "../src/synapse-plugins/converter-plugin/converter-plugin-backend.vala"
	G_OBJECT_CLASS (synapse_converter_plugin_backend_parent_class)->finalize (obj);
#line 2767 "converter-plugin-backend.c"
}

static GType
synapse_converter_plugin_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseConverterPluginBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_converter_plugin_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseConverterPluginBackend), 0, (GInstanceInitFunc) synapse_converter_plugin_backend_instance_init, NULL };
	GType synapse_converter_plugin_backend_type_id;
	synapse_converter_plugin_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "SynapseConverterPluginBackend", &g_define_type_info, 0);
	SynapseConverterPluginBackend_private_offset = g_type_add_instance_private (synapse_converter_plugin_backend_type_id, sizeof (SynapseConverterPluginBackendPrivate));
	return synapse_converter_plugin_backend_type_id;
}

GType
synapse_converter_plugin_backend_get_type (void)
{
	static volatile gsize synapse_converter_plugin_backend_type_id__once = 0;
	if (g_once_init_enter (&synapse_converter_plugin_backend_type_id__once)) {
		GType synapse_converter_plugin_backend_type_id;
		synapse_converter_plugin_backend_type_id = synapse_converter_plugin_backend_get_type_once ();
		g_once_init_leave (&synapse_converter_plugin_backend_type_id__once, synapse_converter_plugin_backend_type_id);
	}
	return synapse_converter_plugin_backend_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 298 "../src/synapse-core/data-sink.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2799 "converter-plugin-backend.c"
		gssize i;
#line 298 "../src/synapse-core/data-sink.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 298 "../src/synapse-core/data-sink.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 298 "../src/synapse-core/data-sink.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2807 "converter-plugin-backend.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 298 "../src/synapse-core/data-sink.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 298 "../src/synapse-core/data-sink.vala"
	g_free (array);
#line 2822 "converter-plugin-backend.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 298 "../src/synapse-core/data-sink.vala"
	if (array) {
#line 298 "../src/synapse-core/data-sink.vala"
		while (((gpointer*) array)[length]) {
#line 298 "../src/synapse-core/data-sink.vala"
			length++;
#line 2836 "converter-plugin-backend.c"
		}
	}
#line 298 "../src/synapse-core/data-sink.vala"
	return length;
#line 2841 "converter-plugin-backend.c"
}

